function Template_Canoe_Descente_96x16()
	-- En course ...
	ledTemplateRunning = {};
	ledTemplateRunning.fields = {
		-- Dossard
		{ data = 'bib', command = 'text', font = 't8x8', color = 'white', x = 0, y = 0},
		-- Identit
		{ data = 'identity', command = 'text', font = 't5x7', color = 'yellow', x = 24, y = 0 },
		-- Temps Tournant
		{ command = 'rectangle', color = 'black', x = 20, y = 8 , w = 60, h = 7},
		{ 
			data = 'time',
			command = 'text', 
			font = 't8x8', 
			color = 'green', 
			x = 20,
			w = 60,
			align = 'R',
			y = 8
		},
		-- Animation en course
		{ command = 'animation', name = 'clock8' , milliseconds = 40, x = 2, y = 8, loopback = 'std' },
	};
	
	-- Inter ...
	ledTemplateInter = {};
	ledTemplateInter.fields = {
		-- Dossard
		{ data = 'bib', command = 'text', font = 't8x8', color = 'white', x = 0, y = 0},
		-- Identit
		{ data = 'identity', command = 'text', font = 't5x7', color = 'yellow', x = 24, y = 0},
		-- I?: 
		{ data = function(field, tpl)
				return 'I'..tostring(tpl.data.inter)..':';
			end,
			command = 'text', 
			font = 't8x8', 
			color = 'green', 
			x = 0, 
			y = 8 
		},
		-- Temps 
		{ data = 'time_chrono', command = 'text', font = 't8x8', color = 'yellow', x = 20, y = 8 },
		-- Ecart 
		{ 
			data = 'diff_chrono', 
			command = 'text', 
			font = 't5x7', 
			color = function(field, tpl)
				if type(tpl.data.diff_chrono) == 'string' 
				and string.len(tpl.data.diff_chrono) > 0 
				and string.sub(tpl.data.diff_chrono,1,1) == '-' then
					return 'green'; 
				else 
					return 'red';  
				end
			end, 
			x = 72, 
			w = 24,
			align = 'R',
			y = 8 
		},
	};
	
	-- A l'arrive ...
	ledTemplateFinish = {};
	ledTemplateFinish.fields = {
		-- Dossard
		{ data = 'bib', command = 'text', font = 't8x8', color = 'white', x = 0, y = 0},
		-- Identit
		{ data = 'identity', command = 'text', font = 't5x7', color = 'yellow', x = 24, y = 0},
		-- Temps 
		{ data = 'time_chrono', command = 'text', font = 't8x8', color = 'white', x = 0, y = 8 },
		-- Ecart 
		{ 
			data = function(field, tpl)
				if type(tpl.data.diff_chrono) == 'string' 
				and string.len(tpl.data.diff_chrono) > 0 then
					return '['..tpl.data.diff_chrono..']';
				else
					return '';
				end
			end, 
			command = 'text', 
			font = 't5x7', 
			color = function(field, tpl) 
				if tpl.data.rk_chrono ~= nil and tpl.data.rk_chrono == '1' then 
					return 'green'; 
				else 
					return 'red';  
				end
			end, 
			x = 51, 
			y = 8 
		},
		-- Clt 
		{ 
			condition = function(field, tpl) 
				-- Affichage du Classement si plus petit que 100 et cart en dessous de 10s ...
				if tonumber(tpl.data.rk_chrono or '0') < 100 
				and tonumber(tpl.data.diff_chrono_ms or '0') < 10000 then
					return true;
				else
					return false;
				end
			end,
			data = 'rk_chrono', 
			command = 'text', 
			font = 't8x8', 
			color = function(field, tpl) 
				if tpl.data.rk_chrono ~= nil and tpl.data.rk_chrono == '1' then 
					return 'green'; 
				else 
					return 'red';  
				end
			end, 
			x = 81, 
			w = 16,
			align = 'R',
			y = 8 
		}
	};
end

function Template_Canoe_Descente_64x16()
	-- En course ...
	ledTemplateRunning = {};
	ledTemplateRunning.fields = {
		-- Dossard
		{ data = 'bib', command = 'text', font = 't8x8', color = 'white', x = 0, y = 0},
		-- Identit
		{ data = 'identity', command = 'text', font = 't4x5', color = 'yellow', x = 24, y = 2 },
		-- Temps Tournant
		{ command = 'rectangle', color = 'black', x = 10, y = 8 , w = 54, h = 7},
		{ 
			data = 'time',
			command = 'text', 
			font = 't8x8', 
			color = 'green', 
			x = 10,
			w = 54,
			align = 'R',
			y = 8
		},
		-- Animation en course
		{ command = 'animation', name = 'clock8' , milliseconds = 40, x = 0, y = 8, loopback = 'std' },
	};
	
	-- Inter ...
	ledTemplateInter = {};
	ledTemplateInter.fields = {
		-- Dossard
		{ data = 'bib', command = 'text', font = 't8x8', color = 'white', x = 0, y = 0},
		-- Identit
		{ data = 'identity', command = 'text', font = 't4x5', color = 'yellow', x = 24, y = 2},
		-- I?: 
		{ data = function(field, tpl)
				return 'I'..tostring(tpl.data.inter)..':';
			end,
			command = 'text', 
			font = 't8x8', 
			color = 'green', 
			x = 0, 
			y = 8 
		},
		-- Temps 
		{ data = 'time_chrono', command = 'text', font = 't8x8', color = 'yellow', x = 20, y = 8 },
	};
	
	-- A l'arrive ...
	ledTemplateFinish = {};
	ledTemplateFinish.fields = {
		-- Dossard
		{ data = 'bib', command = 'text', font = 't8x8', color = 'white', x = 0, y = 0},
		-- Identit
		{ data = 'identity', command = 'text', font = 't4x5', color = 'yellow', x = 24, y = 2},
		-- Temps 
		{ data = 'time_chrono', command = 'text', font = 't8x8', color = 'white', x = 0, y = 8 },
		-- Clt 
		{ 
			data = 'rk_chrono', 
			command = 'text', 
			font = 't8x8', 
			color = function(field, tpl) 
				if tpl.data.rk_chrono ~= nil and tpl.data.rk_chrono == '1' then 
					return 'green'; 
				else 
					return 'red';  
				end
			end, 
			x = 41, 
			w = 24,
			align = 'R',
			y = 8 
		}
	};
end

function Template_Canoe_Descente()
	if device.led_col == 96 then
		Template_Canoe_Descente_96x16();
	else 
		Template_Canoe_Descente_64x16();
	end
end

ledDisplayTemplate = 
{ 
	{ code = 'canoe_des', label = 'Canoe Descente', fn = Template_Canoe_Descente },
}
