-- RaceResult gere systeme Actif et Passif 
-- connection ethernet entre le decodeur et l'ordi en IP Fixe obligatoire
-- systeme Actif gestion de 8 N de Loop  et 8 N de canal sur un memes decodeur 
-- Gestion du comptage de nombre de tour de pena si on active le couttourpena sur une boucle
-- aller dans gestion des options
-- Gestion de table de corespondance Gnric a tt les vnements ou gestion de table propre  l'vnement traiter
-- dans les deux cas la mm table sert a plusieurs dcodeur sur le memes EVT
-- 19/02/2023 version = 12.0
	-- Gestion multi jour
	-- Gestion Multitour par skiFFS si on met -1 ds le Nb tour
	-- Verif Ok
-- 20/02/2023 version = 12.1
	-- corection bug vidage table 
-- 20/02/2023 version = 12.2
	-- mise en place du compteur de pena / Tir
	-- reste e finaliser
-- 26/02/2023 version = 12.3
	-- raz des Alert pour limiter les messages inutil ds le fonctionnement
-- 28/09/2023 version = 12.3
	-- Acces direct au config et pong
-- 28/09/2023 version = 12.4
	-- rajout de 2 fonction pour arreter le timer et le remetre en fonction
dofile('./interface/interface.lua');
dofile('./interface/adv.lua');
dofile('./interface/device.lua');

-- Information : Numro de Version, Nom, Interface, adresse IP, N de port donn par race result
function device.GetInformation(node)
	return { 
		version = 12.4, 
		code = 'RaceResult_IP', 
		name = function() 
					local txt = 'RaceResult IP';
					if node ~= nil then
						txt = txt..': ['..node:GetAttribute('hostname')..']'; 
					end
					return txt;
				end, 
		class = 'chrono', 
		interface = { { type='tcp', hostname = '192.168.2.214', port = 3601 } } 
	};
end	

-- Creation et initialisation table RaceResult
RaceResult = {};

-- Timer 
RaceResult.timerDelay = 500;

-- Timer 
RaceResult.timerDelayConnect = 10000;

-- Racings
RaceResult.alive = 0;

-- Code Competition 
RaceResult.code_competition = -1;

-- Actif ou pas
RaceResult.ActiveStart = "Non Actif";

-- status
RaceResult.GetStatus = "Ko";

-- Directory par dfaut
RaceResult.directory = './device';

-- nb de lignes 
nbLignes = 0;

-- Nb de tour
NbTourRealiser = 0;

--activation de la fonction debugage
RaceResult.debugage = false;

--activation de la chrono sur plusieurs jour
RaceResult.Evt_multi_Jour = false;

-- numero de passage ou le decodeur doit envoyer le chrono par default
passage = '';

-- variable utiliser si on met 2 trackbox sur une mm ligne
ImpulSynchro = nil;

-- recherche du dcalage horaire local par rapport  l'heure UTC Pour la lecture d'un fichier de trackbox
DiffGMT = app.GetTimeZone()
RaceResult.DiffGMT = tonumber(string.sub(DiffGMT, 2, 5));

function Alert(txt)
	RaceResult.gridMessage:AddLine(txt);
end

function Success(txt)
	RaceResult.gridMessage:AddLineSuccess(txt);
end

function Warning(txt)
	RaceResult.gridMessage:AddLineWarning(txt);
end

function Error(txt)
	RaceResult.gridMessage:AddLineError(txt);
end

-- Ouverture
function device.OnInit(params, node)

	-- Appel OnInit Metatable
	mt_device.OnInit(params);
	
	theParams = params;
	node = node;
	
	--passage = node:GetAttribute('config_Passage');  -- N de passage 0 depart, -1 arrive, 1..2..3 N inter
	
	-- Creation Panel
	local panel = wnd.CreatePanel({ parent = app.GetAuiFrame() });
	panel:LoadTemplateXML({ 
		icon = './logo/Mini-logo-RaceResult.png',
		xml = './device/raceresult.xml',
		node_name = 'root/panel',
		node_attr = 'name',
		node_value = 'dashboard'
	});

	RaceResult.panel = panel;
	
	-- Initialisation des Controles 
	RaceResult.gridMessage = panel:GetWindowName('message');

	-- initialisation de la table RaceResult
	RaceResult.dbSki = sqlBase.Clone();
	
	TabletagID_Passings = RaceResult.dbSki:GetTable('Evenement_tagID_Passings');
	if type(TabletagID_Passings) ~= 'userdata' then
		Warning('Table Evenement_tagID_Passings Ko !');
	end
	
	TabletagID_Tour = RaceResult.dbSki:GetTable('Evenement_tagID_Tour');
	if type(TabletagID_Tour) ~= 'userdata' then
		Warning('Table Evenement_tagID_Tour Ko !');
	end
	
	TabletagID_Correspondance = RaceResult.dbSki:GetTable('tagID_Correspondance');
	if type(TabletagID_Correspondance) ~= 'userdata' then
		Warning('Table tagID_Correspondance Ko !');
	end
	
	TableTagID_Finish = RaceResult.dbSki:GetTable('tagID_Finish');
	if type(TableTagID_Finish) ~= 'userdata' then
		Warning('Table tagID_Finish Ko !');
	end
	
	TabletagID_TourPena = RaceResult.dbSki:GetTable('tagID_TourPena');
	if type(TabletagID_TourPena) ~= 'userdata' then
		Warning('Table tagID_TourPena Ko !');
	end
	
	-- tEpreuve = RaceResult.dbSki:GetTable('Epreuve');
	
	-- ToolBar
	RaceResult.tb = panel:GetWindowName('tb');
	RaceResult.tb_start = RaceResult.tb:AddTool("Start", "./res/32x32_chrono_v3.png", "Start",  itemKind.DROPDOWN);
	RaceResult.tb_outil = RaceResult.tb:AddTool("Outil RaceResult", "./res/32x32_configure.png", "outils",  itemKind.DROPDOWN);
	RaceResult.tb_OnGestionTableCorres = RaceResult.tb:AddTool("Import table corespondance", "./res/32x32_divide_column.png");
	RaceResult.tb_Param = RaceResult.tb:AddTool("Prametrage", "./res/32x32_config.png", "Parametrage plage dossards relais",  itemKind.DROPDOWN);
	RaceResult.tb:AddSeparator();
	RaceResult.tb_Base = RaceResult.tb:AddTool("Nettoyage Base SQL.", "./res/32x32_sql.png", "Outils de Nettoyage Base SQL.",  itemKind.DROPDOWN);
	RaceResult.tb:AddSeparator();
	
---- Sous menu table outils
	local menuSend =  menu.Create();
	menuSend:AppendSeparator();	
	RaceResult.tb_outil_ping = menuSend:Append({label="Test Connection dcodeur ?", image ="./res/32x32_time-admin.png"});
	menuSend:AppendSeparator();
	RaceResult.tb_outil_mode = menuSend:Append({label="Ligne de Dtection Active ou pas ?", image ="./res/vpe32x32_search.png"});
	menuSend:AppendSeparator();
	RaceResult.tb_outil_protocol = menuSend:Append({label="Protocol du decodeur utilis ?", image ="./res/32x32_tasks.png"});
	menuSend:AppendSeparator();	
	RaceResult.tb_outil_status = menuSend:Append({label="Status du dcodeur 'on/off", image ="./res/chrono32x32_traffic_light.png"});
	menuSend:AppendSeparator();	
	RaceResult.tb_outil_passings = menuSend:Append({label="Nb de Passings enregistrer ds le dcodeur ?", image ="./res/32x32_time-admin.png"});
	menuSend:AppendSeparator();	
	RaceResult.tb_outil_gettime = menuSend:Append({label="heure du dcodeur ?", image ="./res/chrono32x32_clock_inter.png"});
	menuSend:AppendSeparator();	
	RaceResult.tb_outil_OnChargeBat = menuSend:Append({label="Niveau de Charge Batterie", image ="./res/32x32_battery_half.png"});
	menuSend:AppendSeparator();
	RaceResult.tb_outil_OnRechargeFichier = menuSend:Append({label="Recharge d'un fichier SAV du dcodeur", image ="./res/32x32_lua.png"});
	menuSend:AppendSeparator();
	RaceResult.tb_outil_OnRechargeTagId = menuSend:Append({label="Rechargement Squence", image ="./res/32x32_update.png"});
	menuSend:AppendSeparator();
	RaceResult.tb_outil_OnStartGPS_Time = menuSend:Append({label="Synchro du GPS Time", image ="./res/32x32_antenna.png"});
	menuSend:AppendSeparator();
	RaceResult.tb_outil_OnStartOperation = menuSend:Append({label="Activation Du chrono", image ="./res/32x32_antenna.png"});
	menuSend:AppendSeparator();
	RaceResult.tb_outil_OnStopOperation = menuSend:Append({label="Mise en stanby du Chrono", image ="./res/32x32_stop.png"});
	menuSend:AppendSeparator();
	RaceResult.tb_outil_OnStartUpload = menuSend:Append({label="Activation De l'Upload", image ="./res/32x32_antenna.png"});
	menuSend:AppendSeparator();
	RaceResult.tb_outil_OnStopUpload = menuSend:Append({label="Dsctivation De l'Upload", image ="./res/32x32_stop.png"});
	RaceResult.tb:SetDropdownMenu(RaceResult.tb_outil:GetId(), menuSend);
	
---- Sous menu Start	
	local menuSend =  menu.Create();
	menuSend:AppendSeparator();	
	RaceResult.tb_Stop_Timer = menuSend:Append({label="Arret du timer ", image ="./res/vpe32x32_close.png"});
	menuSend:AppendSeparator();	
	RaceResult.tb_restart_Timer = menuSend:Append({label="Relance du timer", image ="./res/vpe32x32_refresh.png"});
	RaceResult.tb:SetDropdownMenu(RaceResult.tb_start:GetId(), menuSend);
	
---- Sous menu parametre	
	local menuSend =  menu.Create();
	menuSend:AppendSeparator();	
	RaceResult.tb_Param_Options = menuSend:Append({label="Configuration des options (Nb Tour / Passage) ", image ="./res/32x32_options.png"});
	menuSend:AppendSeparator();	
	RaceResult.tb_Param_TagIdFinish = menuSend:Append({label="Vider la Table des tagID dj arrivs ", image ="./res/32x32_background.png"});
	menuSend:AppendSeparator();
	RaceResult.tb_Param_tagID_TourPena = menuSend:Append({label="Vider la Table de memo des nb de tours de Pna fait ", image ="./res/32x32_background.png"});
	menuSend:AppendSeparator();
	RaceResult.tb_Param_Passing = menuSend:Append({label="Mise a zro du compteur passing", image ="./res/32x32_update.png"});
	menuSend:AppendSeparator();
	RaceResult.tb_Param_Socket = menuSend:Append({label="Rinitialisation de la connection au dcodeur", image ="./res/32x32_postition_horizontal.png"});
	RaceResult.tb:SetDropdownMenu(RaceResult.tb_Param:GetId(), menuSend);

---- Sous menu Base	
	local menuSend =  menu.Create();
	RaceResult.tb_BasetagID_Finish = menuSend:Append({label="Vider compltement la Table de mmorisation des Tad-ID dtecter ", image ="./res/32x32_clear.png"});
	menuSend:AppendSeparator();
	RaceResult.tb_BasetagID_TourPena = menuSend:Append({label="Vider compltement la Table de mmorisation des nb de tours de Pna", image ="./res/32x32_clear.png"});
	menuSend:AppendSeparator();
	RaceResult.tb_BasetagID_Correspondance = menuSend:Append({label="Vider compltement la Table de correspondance", image ="./res/32x32_clear.png"});
	RaceResult.tb:SetDropdownMenu(RaceResult.tb_Base:GetId(), menuSend);

	
	-- Static Connect
	RaceResult.Connect = wnd.CreateStaticText({parent = RaceResult.tb, label = "Test Connect", style = wndStyle.ALIGN_LEFT});
	RaceResult.Connect:SetLabel("Non Connect");
	RaceResult.tb:AddControl(RaceResult.Connect);
	RaceResult.tb:AddSeparator();	
	
	-- Static Info
	RaceResult.info = wnd.CreateStaticText({parent = RaceResult.tb, label = "Timer : ------  Passings : ----/----", style = wndStyle.ALIGN_LEFT});
	RaceResult.tb:AddControl(RaceResult.info);
	RaceResult.tb:AddSeparator();	

	-- Niveau de Batterie
	RaceResult.battery = wnd.CreateStaticText({parent = RaceResult.tb, label = "Charge Bat =---%", style = wndStyle.ALIGN_LEFT});
	RaceResult.tb:AddControl(RaceResult.battery);
	RaceResult.tb:Realize();

	-- Prise des Evenements (Bind)
	-- de l'Onglet principal
	RaceResult.panel:Bind(eventType.MENU, OnStartRaceResult, RaceResult.tb_start);
	RaceResult.panel:Bind(eventType.MENU, OnraceResultOutils, RaceResult.tb_outil);
	RaceResult.panel:Bind(eventType.MENU, OnOpenTableCorespondance, RaceResult.tb_OnGestionTableCorres);

	-- de l'onglet du sous menu outil 
	RaceResult.panel:Bind(eventType.MENU, OnTimerKo, RaceResult.tb_Stop_Timer);
	RaceResult.panel:Bind(eventType.MENU, OnTimerOk, RaceResult.tb_restart_Timer);

	-- de l'onglet du sous menu outil 
	RaceResult.panel:Bind(eventType.MENU, OnPing, RaceResult.tb_outil);	-- Bouton principal ...
	RaceResult.panel:Bind(eventType.MENU, OnPing, RaceResult.tb_outil_ping);
	RaceResult.panel:Bind(eventType.MENU, OnMode, RaceResult.tb_outil_mode);
	RaceResult.panel:Bind(eventType.MENU, OnProtocol, RaceResult.tb_outil_protocol);
	RaceResult.panel:Bind(eventType.MENU, OnStatus, RaceResult.tb_outil_status);
	RaceResult.panel:Bind(eventType.MENU, OnPassings, RaceResult.tb_outil_passings);
	RaceResult.panel:Bind(eventType.MENU, OnGetTime, RaceResult.tb_outil_gettime);
	RaceResult.panel:Bind(eventType.MENU, OnChargeBat, RaceResult.tb_outil_OnChargeBat);
	RaceResult.panel:Bind(eventType.MENU, OnRechargeFichier, RaceResult.tb_outil_OnRechargeFichier);
	RaceResult.panel:Bind(eventType.MENU, OnRechargeTagId, RaceResult.tb_outil_OnRechargeTagId);
	RaceResult.panel:Bind(eventType.MENU, OnStartGPS_Time, RaceResult.tb_outil_OnStartGPS_Time);
	RaceResult.panel:Bind(eventType.MENU, OnStartOperation, RaceResult.tb_outil_OnStartOperation);
	RaceResult.panel:Bind(eventType.MENU, OnStopOperation, RaceResult.tb_outil_OnStopOperation);
	RaceResult.panel:Bind(eventType.MENU, OnStartUpload, RaceResult.tb_outil_OnStartUpload);
	RaceResult.panel:Bind(eventType.MENU, OnStopUpload, RaceResult.tb_outil_OnStopUpload);

-- onglet du sous menu parametre 
	RaceResult.panel:Bind(eventType.MENU, OnOpenOptions, RaceResult.tb_Param);
	RaceResult.panel:Bind(eventType.MENU, OnOpenOptions, RaceResult.tb_Param_Options);
	RaceResult.panel:Bind(eventType.MENU, OnDeleteTagIdFinish, RaceResult.tb_Param_TagIdFinish);
	RaceResult.panel:Bind(eventType.MENU, OnDeleteTagIdTourPena,RaceResult.tb_Param_tagID_TourPena);
	RaceResult.panel:Bind(eventType.MENU, OnClearPassing, RaceResult.tb_Param_Passing);
	RaceResult.panel:Bind(eventType.MENU, OnReOpenSocket, RaceResult.tb_Param_Socket);
	
-- onglet du sous menu Base 
	RaceResult.panel:Bind(eventType.MENU, OnDeleteTableTagIdFinish, RaceResult.tb_BasetagID_Finish);
	RaceResult.panel:Bind(eventType.MENU, OnDeleteTabletagID_TourPena, RaceResult.tb_BasetagID_TourPena);
	RaceResult.panel:Bind(eventType.MENU, OnDeleteTabletagID_Correspondance, RaceResult.tb_BasetagID_Correspondance);
		
-- Chargement des Informations de la Course ...
	RaceResult.code_competition = -1;
	local rc, raceInfo = app.SendNotify('<race_load>');
	if rc == true then
		tEvenement = raceInfo.tables.Evenement;
		RaceResult.code_competition = tEvenement:GetCellInt('Code', 0);
		RaceResult.code_manche = raceInfo.Code_manche or 1 ;
		tEpreuve = raceInfo.tables.Epreuve;
		RaceResult.date_competition = tEpreuve:GetCell('Date_epreuve', 0);
		RaceResult.Nb_Epreuve = tEpreuve:GetNbRows();
		Success('Comptition '..tostring(RaceResult.code_competition)..' ok .. du:'..RaceResult.date_competition);
	end
	
-- Recherche et creation d'une variable pour l'Adresse IP et le port utilser pour le decodeur actif OK
------ demander a pierre si c ok ????????????????????????????????????????????????????????????????????????????????????
	local sockClient = mt_device.obj;
	if sockClient ~= nil then
		local tPeer = sockClient:GetPeer();
		ActiveID = tPeer.ip;
		ActivePort = tPeer.port;
	-- Alert("ActiveID :"..ActiveID.." Port: "..ActivePort);	
	else
		ActiveID = "";
		ActivePort = "";
		Warning('pas de connection ...');
	end
	
-- Recherche si un evenement existe dans la table Evenement_tagID_Passings OK
	cmd = "Select * From Evenement_tagID_Passings Where Code_evenement = "..RaceResult.code_competition.." and AdresseIP = '"..ActiveID.."'";
	TableTagID_Passings = RaceResult.dbSki:GetTable('Evenement_tagID_Passings');
	RaceResult.dbSki:TableLoad(TableTagID_Passings, cmd);	
	
	if TableTagID_Passings:GetNbRows() == 0 then
	-- Alert("pas d'vnement Dans la table Evenement_tagID_Passings on la crer");
	-- creation de la variable Passing Current (nb de transpondeur detecter dans la ligne chrono)		
	RaceResult.passingCurrent = 0;
	LoopID = 'Loop0';
	LoopCanal = 'LoopCanal0';
	TypeTable = 'ND';
	CountTourActif = 0;
	SystemeActif = 0;
	Evt_multi_Jour = 0;
	RaceResult.prem_Jour_Evt = os.date("%d-%m-%Y");
	-- creation de variables TypeTable et CodeTypeTable(permetant de travailler une table gnrique a tt les evt ou une table spcifique  l'EVT)
	CodeTypeTable = RaceResult.code_competition;
	--delai double detection
	DelayDoubleDetect = 120000; -- =  2 minutes // 600000 =  10 minutes   ///  60000 =  1 min
	-- ecriture des parametres dans la Evenement_tagID_Passings et du type table.
	AddTabletagID_Passings(RaceResult.code_competition,ActiveID,ActivePort,LoopID,LoopCanal,RaceResult.passingCurrent,TypeTable,DelayDoubleDetect,CountTourActif,SystemeActif,Evt_multi_Jour,tostring(RaceResult.prem_Jour_Evt));		
		Warning("pas de table de corespondace pour cet vnement ...");
		Warning("Penser  aller dans l'onglet gestion pour importer une table avant de chronometrer...");
	else
-- si il y a une ligne dans Evenement_tagID_Passings On prend les valeurs de la table pour renseigner les variables 
		RaceResult.passingCurrent = TableTagID_Passings:GetCellInt('Passings', 0);
		if TableTagID_Passings:GetCellInt('Evt_multi_Jour', 0) == 0 then
			RaceResult.Evt_multi_Jour = false;
			RaceResult.prem_Jour_Evt = TableTagID_Passings:GetCell('prem_Jour_Evt', 0);
		else
			RaceResult.Evt_multi_Jour = true;
			RaceResult.prem_Jour_Evt = TableTagID_Passings:GetCell('prem_Jour_Evt', 0);
		end
		--Alert("RaceResult.passingCurrent ="..RaceResult.passingCurrent);
		TypeTable = TableTagID_Passings:GetCell('TypeTable', 0);
		-- Alert("TypeTable = "..TypeTable);
		-- DelayDoubleDetect = TableTagID_Passings:GetCell('DelayDoubleDetect', 0);
		-- Alert("RaceResult.passingCurrent ="..RaceResult.passingCurrent.."/ TypeTable :"..TypeTable);
			if TypeTable == 'GEN' then
				CodeTypeTable = 0;
			else
				CodeTypeTable = RaceResult.code_competition ;
			end
	end
	
	-- On recherche si il y a une ou plusieurs lignes de crer ds la table TabletagID_Tour pour l'evt
	-- Si pas de ligne on inscrit dans la table	
	cmd = "Select * From Evenement_tagID_Tour Where Code_evenement = '"..RaceResult.code_competition.."' And AdresseIP = '"..ActiveID.."' Order by Code_epreuve";
	local NbEpr_TabletagID_Tour = RaceResult.dbSki:TableLoad(TabletagID_Tour, cmd):GetNbRows();
	Alert('nb epreuve = '..NbEpr_TabletagID_Tour);
	-- cmd = "select * from Epreuve where Code_evenement = "..RaceResult.code_competition
	-- local NbEpreuve = RaceResult.dbSki:TableLoad(tEpreuve, cmd):GetNbRows();
	if NbEpr_TabletagID_Tour == 0 or NbEpr_TabletagID_Tour ~= RaceResult.Nb_Epreuve then
		-- cmd = "select * from Epreuve where Code_evenement = "..RaceResult.code_competition
		-- local NbEpreuve = RaceResult.dbSki:TableLoad(tEpreuve, cmd):GetNbRows();
		if RaceResult.Nb_Epreuve >=1 then
			for i=0, RaceResult.Nb_Epreuve-1 do
				local Code_epreuve = i+1;
				local LoopID = 'Loop0';
				local LoopCanal = 'LoopCanal0';
				local ID_1er_Inter = 1;
				-- local passage = -1;
				Id_Passage = -1;
				local Tour = 0;
				local Tps_Tour = 0;
				local Tps_Tour_Pena = 0;
				AddTabletagID_Tour(RaceResult.code_competition,ActiveID,Code_epreuve,LoopID,LoopCanal,ID_1er_Inter,Id_Passage,Tour,Tps_Tour,Tps_Tour_Pena);
			end
		end
		-- Alert('Id_Passage = '..Id_Passage);
	else
		Id_Passage = TabletagID_Tour:GetCellInt('passage', 0);
		-- Alert('Id_Passage = '..Id_Passage);
	end
-- Recherche si une table de corespondance existe dans la table tagID_Correspondance
	cmd = "Select * From tagID_Correspondance Where Code_evenement = "..CodeTypeTable.." Order by Dossard";
	if RaceResult.dbSki:TableLoad(TabletagID_Correspondance, cmd):GetNbRows() == 0 then
		Alert("pas de Table de correspondance pour cet vnement : "..RaceResult.code_competition);
	else
	-- Alert("TypeTable ="..TypeTable);
		if TypeTable == 'GEN' then
			Alert("Utilisation de la table Gnrique pour l'EVT  : "..RaceResult.code_competition.." avec "..TabletagID_Correspondance:GetNbRows().." lignes cres");
		elseif TypeTable == 'EVT' then
			Alert("Utilisation de la table spcifique  l'vnement N: "..RaceResult.code_competition.." avec "..TabletagID_Correspondance:GetNbRows().." lignes cres");
		else
			Alert("pas de table de corespondance pour l'EVT  : "..RaceResult.code_competition);
		end	
	end
			
-- creation de la variables PassingCount (nb de transpondeur detecter par la ligne chrono)
		RaceResult.RecordsCount = 0;
		--Alert("passingCurrent :"..RaceResult.passingCurrent.."/ "..RaceResult.RecordsCount);

-- Affichage ...
	panel:Show(true);
	
	local mgr = app.GetAuiManager();
	
	local caption = '/ '..ActiveID;
	
	mgr:AddPane(panel, {
		name = 'panel_raceresult_'..ActiveID,
		icon = './res/Mini-logo-raceresult.png',
		caption = "Tableau de Bord Race Result IP: "..ActiveID..' => Passage N '..Id_Passage,
		caption_visible = true,
		close_button = false,
		pin_button = true,
		show = true,

		float = true, 
		-- position de la fenetre a l'ouverture {horizontal , verticale}
		floating_position = {1000, 40},
		-- taille de la {fenetre L , H}
		floating_size = {700, 300},
		dockable = false
		
	});

	mgr:Update();
	
	-- Creation du Timer connect pour la baterie
	RaceResult.timerConnect = timer.Create(RaceResult.panel);
	if RaceResult.timerConnect ~= nil then
		RaceResult.timerConnect:Start(RaceResult.timerDelayConnect);
	end
	RaceResult.panel:Bind(eventType.TIMER, OnTimerBatConnect, RaceResult.timerConnect);

	-- affichage pour voir la date du 1er jour du chrono si on est en gestion multi jour
	DateJour = os.date("%Y-%m-%d")
	if RaceResult.Evt_multi_Jour == true then
		Warning("Mode Evt Ulti jour Activ jour des arrive des preuve"..RaceResult.date_competition);
		Alert("1er jour de reference de l'evt:"..RaceResult.prem_Jour_Evt);
	else
		Alert("DateJour: "..os.date("%d/%m/%Y"));
	end	

end

-- Fermeture
function device.OnClose()
	RaceResult.Stop = true;
	
	if RaceResult.panel ~= nil then
		-- On Ignore les "event" qui peuvent encore tre dans la pile ...
		RaceResult.panel:UnbindAll();
	end

	if RaceResult.timer ~= nil then
		RaceResult.timer:Delete();
	end
	
	if RaceResult.timerConnect ~= nil then
		RaceResult.timerConnect:Delete();
	end
	
	if RaceResult.watchDogConnect ~= nil then
		RaceResult.watchDogConnect:Delete();
	end
	
	if RaceResult.panel ~= nil then
		local mgr = app.GetAuiManager();
		mgr:DeletePane(RaceResult.panel);
	end

-- Appel OnClose Metatable
	mt_device.OnClose();
end

--Outils:

function OnTimerKo()
	if RaceResult.timer ~= nil then
		RaceResult.timer:Delete();
		RaceResult.timer = nil;
		Alert("Mise en sommeil du timer");
	end
end

function OnTimerOk()
	if RaceResult.timer ~= nil then
		Alert("Timer dj Actif");
	else
		RaceResult.timer = timer.Create(RaceResult.panel);
		if RaceResult.timer ~= nil then
			RaceResult.timer:Start(RaceResult.timerDelay);
		end
		RaceResult.panel:Bind(eventType.TIMER, OnTimer, RaceResult.timer);
		Alert("Start timer");
	end
end

-- Nettoyage de la base de donne
function OnDeleteTableTagIdFinish()
	if RaceResult.panel:MessageBox("Confirmation du Vidage complet de la table de mmorisation de Tag-ID dtect ?\n\n Cette opration effecera compltement le contenue de la table demmorisation de Tag-ID dtect tout vnements confondus ", "Confirmation du Vidage de la table de mmorisation de Tag-ID dtect", msgBoxStyle.YES_NO+msgBoxStyle.ICON_INFORMATION) ~= msgBoxStyle.YES then
		return;
	end
	cmd = "Delete From tagID_Finish ";
	RaceResult.dbSki:Query(cmd);
end
	
function OnDeleteTabletagID_TourPena()
	if RaceResult.panel:MessageBox("Confirmation du Vidage complet de la table de mmorisation des Pnalits ?\n\n Cette opration effecera compltement le contenue de la table de mmorisation des Pnalits tout vnements confondus ", "Confirmation du Vidage de la table de mmorisation des Pnalits ", msgBoxStyle.YES_NO+msgBoxStyle.ICON_INFORMATION) ~= msgBoxStyle.YES then
		return;
	end
	cmd = "Delete From tagID_TourPena ";
	RaceResult.dbSki:Query(cmd);
end

function OnDeleteTabletagID_Correspondance()
	if RaceResult.panel:MessageBox("Confirmation du Vidage complet de la table de corespondance ?\n\n Cette opration effecera compltement le contenue de la table de corespondance tout vnements confondus ", "Confirmation du Vidage de la table de corespondance", msgBoxStyle.YES_NO+msgBoxStyle.ICON_INFORMATION) ~= msgBoxStyle.YES then
		return;
	end
	cmd = "Delete From tagID_Correspondance ";
	RaceResult.dbSki:Query(cmd);
end

	-- fonction pour mettre a jour le bandeau de donne  detection lue / fichier // timer //  baterie
function OngetInfo(detectionlue)
	RaceResult.info:SetLabel("Timer :"..tostring(RaceResult.alive)..
													" Passings : "..tostring(RaceResult.passingCurrent)..
													"/"..tostring(RaceResult.RecordsCount)..
													"-Decodeur.")
												;															
end
	-- Fonction des tables de correspondance
		--fonction pour Vider une table de corespondance	
function OnClearTableCorres(evt)
	if RaceResult.panel:MessageBox("Confirmation du Vidage de la table de corespondance ?\n\nCette opration effecera le contenue de la table corespondance de cet vnement", "Confirmation du Vidage de la table de corespondance", msgBoxStyle.YES_NO+msgBoxStyle.ICON_INFORMATION) ~= msgBoxStyle.YES then
		return;
	end
	-- Alert ("CodeTypeTable = "..CodeTypeTable.."et  TypeTable = ".. TypeTable);
	if CodeTypeTable ~= "" or  TypeTable ~= "" then
	cmd = "Delete From tagID_Correspondance Where Code_evenement = "..CodeTypeTable.." And TypeTable = '"..TypeTable.."'";
	RaceResult.dbSki:Query(cmd);
	else
	cmd = "Delete From tagID_Correspondance Where Code_evenement = "..RaceResult.code_competition;
	RaceResult.dbSki:Query(cmd);
	end
	
--	TableCorrespondance:RemoveAllRows();
	cmd = "Select * From tagID_Correspondance Where Code_evenement = "..CodeTypeTable.." and TypeTable = '"..TypeTable.."'";
	RaceResult.dbSki:TableLoad(TabletagID_Correspondance, cmd)
 
	if TabletagID_Correspondance:GetNbRows() >= 1 then
		Warning("la table ne sais pas vider = "..TabletagID_Correspondance:GetNbRows());
	end	
	local TypeTable = 'ND'
	--Alert('je modifi dans la table Evenement_TagID_Passings'..TypeTable)
	cmd = "Update Evenement_tagID_Passings SET TypeTable = '"..TypeTable.."' Where Code_evenement = "..RaceResult.code_competition.." And AdresseIP = '"..ActiveID.."'"
	RaceResult.dbSki:Query(cmd);
	Warning("Vidage table tagID_Correspondance ok...");

	-- Rafraichissement de la grille ...
	local grid = dlgCorespondance:GetWindowName('grid_TableCorrespondance');
	grid:SynchronizeRows();
end

		-- chargement de la table de corespondance
function OnChargeTableCorres(CodeTypeTable, TypeTable)
 if Table.state == true then
	-- Alert("table utiliser pour l'enregistrement:"..TypeTable);
	-- recherche si il y a deja une table de corespondance de charger dans la base
	cmd = "Select * From tagID_Correspondance Where Code_evenement = "..CodeTypeTable.." And TypeTable = '"..TypeTable.."'";
	RaceResult.dbSki:TableLoad(TabletagID_Correspondance, cmd)
 
	-- si il y a deja des lignes ds la tables je demande confirm pour vider puis recharger
	if TabletagID_Correspondance:GetNbRows() >= 1 then
		if RaceResult.panel:MessageBox("Confirmation du chargement de la table de corespondance ?\n\nCette opration effacera la table actuellement dans la base de donne \n avant d'effectuer le rechargement de la table.", "Confirmation du chargement des Tag_ID et Dossards", msgBoxStyle.YES_NO+msgBoxStyle.ICON_INFORMATION) ~= msgBoxStyle.YES then
			return;
		end
		-- Alert ("CodeTypeTable = "..CodeTypeTable.."et  TypeTable = ".. TypeTable);
		if CodeTypeTable ~= "" or  TypeTable ~= "" then
			cmd = "Delete From tagID_Correspondance Where Code_evenement = "..CodeTypeTable.." And TypeTable = '"..TypeTable.."'";
			RaceResult.dbSki:Query(cmd);
		else
			cmd = "Delete From tagID_Correspondance Where Code_evenement = "..RaceResult.code_competition;
			RaceResult.dbSki:Query(cmd);
		end
	
		--	TableCorrespondance:RemoveAllRows();
		cmd = "Select * From tagID_Correspondance Where Code_evenement = "..CodeTypeTable.." and TypeTable = '"..TypeTable.."'";
		RaceResult.dbSki:TableLoad(TabletagID_Correspondance, cmd)
	 
		if TabletagID_Correspondance:GetNbRows() >= 1 then
			Warning("la table ne sais pas vider = "..TabletagID_Correspondance:GetNbRows());
		end
	end
	
	-- si pas de ligne je demnde de confirmer le chargement de la table
	if RaceResult.panel:MessageBox("Confirmation du chargement de la table de corespondance ?\n\nCette opration vas effectuer le chargement de la table.", "Confirmation du chargement des Tag_ID et Dossards", msgBoxStyle.YES_NO+msgBoxStyle.ICON_INFORMATION) ~= msgBoxStyle.YES then
		return;
	end
	--  rechercher le fichier .db3 des squences  relire et le charger en read.db3
	local fileDialog = wnd.CreateFileDialog(
		{ parent = RaceResult.panel },
		"Slection du fichier de correspondance",
		RaceResult.directory, 
		"",
		"*.csv|*.csv",
		fileDialogStyle.OPEN+fileDialogStyle.FD_FILE_MUST_EXIST
	);
	-- Warning("TypeTable = "..TypeTable);
-- prise du chemin du fichier csv
	if fileDialog:ShowModal() == idButton.OK then
		read_csv = string.gsub(fileDialog:GetPath(), app.GetPathSeparator(), "/");
	else 
		return false;
	end
		csvFile = io.open(read_csv);
			Alert ('Chargement de la nouvelle table de corespondance');
		for line in csvFile:lines() do
			local arrayResults = string.Split(line,';');
			if #arrayResults >= 2 then 
				if tonumber(arrayResults[1]) ~= nil and tonumber(arrayResults[1]) > 0 then
				local r = TabletagID_Correspondance:AddRow();
					local TagID = arrayResults[2];
					local Dossard = tonumber(arrayResults[1]);
						if TypeTable == 'GEN' then 
						TabletagID_Correspondance:SetCell("Code_evenement", r, 0);
						elseif TypeTable == 'EVT' then
						TabletagID_Correspondance:SetCell("Code_evenement", r, RaceResult.code_competition);
						end
				TabletagID_Correspondance:SetCell("TagID", r, TagID);		
				TabletagID_Correspondance:SetCell("Dossard", r, Dossard);
				TabletagID_Correspondance:SetCell("TypeTable", r, TypeTable);
				RaceResult.dbSki:TableInsert(TabletagID_Correspondance, r);
				end
			end
		end
		csvFile:close();
		-- Alert('je modifi dans la table Evenement_TagID_Passings'..TypeTable)
		cmd = "Update Evenement_tagID_Passings SET TypeTable = '"..TypeTable.."' Where Code_evenement = "..RaceResult.code_competition.." And AdresseIP = '"..ActiveID.."'"
		RaceResult.dbSki:Query(cmd);
	else
		Warning("pas de type de table designer");
	end 
		--	TableCorrespondance:RemoveAllRows();
	cmd = "Select * From tagID_Correspondance Where Code_evenement = "..CodeTypeTable.." and TypeTable = '"..TypeTable.."' Order by Dossard";
	RaceResult.dbSki:TableLoad(TabletagID_Correspondance, cmd)
	local nbLignes = TabletagID_Correspondance:GetNbRows();
	Warning("Correspondance : "..nbLignes.." ligne ds la table");
	local nbLignes = 0;
	-- Rafraichissement de la grille ...
	local grid = dlgCorespondance:GetWindowName('grid_TableCorrespondance');
	grid:SynchronizeRows();
end

		--fonction pour charger une table gnrique
function OnValidTypeTableGen(evt)
	cmd = "Select * From tagID_Correspondance Where Code_evenement = 0 And TypeTable = 'GEN' Order by Dossard";
	tTabletagID_Correspondance = RaceResult.dbSki:TableLoad(TabletagID_Correspondance, cmd)
 
	 if TabletagID_Correspondance:GetNbRows() >= 1 then
		--Alert('je modifi dans la table TagID_Passings'..TypeTable)
		cmd = "Update Evenement_tagID_Passings SET TypeTable = 'GEN' Where Code_evenement = "..RaceResult.code_competition.." And AdresseIP = '"..ActiveID.."'";
		RaceResult.dbSki:Query(cmd);
		TypeTable = 'GEN';	
		Table.state = true ;
		CodeTypeTable = 0;
		--Alert("Type de Table utiliser pour cet vnement :"..TypeTable);
		-- Rafraichissement de la grille ...
		local grid = dlgCorespondance:GetWindowName('grid_TableCorrespondance');
		grid:SynchronizeRows();
		Success('Validation de l\'utisation d\'une table Gnrique pour cet vnement ! ');
	else
		Alert('Pas de Table Gnric dans la base ski veuiller uploader une table de corespondance');
		Alert('Pour pouvoir vous en servir');
		Table.state = true ;
		CodeTypeTable = 0;
		TypeTable = 'GEN';
		OnChargeTableCorres(0, 'GEN');
		Success("Chargement de la table corespondance Gnric Ok!! Le Type de Table utiliser pour cet vnement est: "..TypeTable);
	end	
	
end

		--fonction pour charger une table qui ne fonctionne que pour l'evenement
function OnValidTypeTableEvt(evt)
	cmd = "Select * From tagID_Correspondance Where Code_evenement = "..RaceResult.code_competition.." And TypeTable = 'EVT' Order by Dossard";
	RaceResult.dbSki:TableLoad(TabletagID_Correspondance, cmd)
	
	if TabletagID_Correspondance:GetNbRows() >= 1 then
		--Alert('je modifi dans la table Evenement_TagID_Passings'..TypeTable)
		cmd = "Update Evenement_tagID_Passings SET TypeTable = 'EVT' Where Code_evenement = "..RaceResult.code_competition.." And AdresseIP = '"..ActiveID.."'";
		RaceResult.dbSki:Query(cmd);
		TypeTable = 'EVT';	
		Table.state = true ;
		CodeTypeTable = tonumber(RaceResult.code_competition);
		-- Alert("Type de Table utiliser pour cet vnement :"..TypeTable);
		-- Rafraichissement de la grille ...
		local grid = dlgCorespondance:GetWindowName('grid_TableCorrespondance');
		grid:SynchronizeRows();
		Success('Validation de l\'utisation d\'une table de correspondance unique  l\'vnement! '..RaceResult.code_competition);
	else
		--Alert('je modifi dans la table Evenement_TagID_Passings'..TypeTable)
		cmd = "Update Evenement_tagID_Passings SET TypeTable = 'EVT'  Where Code_evenement = "..RaceResult.code_competition.." And AdresseIP = '"..ActiveID.."'";
		RaceResult.dbSki:Query(cmd);
		TypeTable = 'EVT';	
		Table.state = true ;
		CodeTypeTable = tonumber(RaceResult.code_competition);
		-- Alert("Type de Table utiliser pour cet vnement :"..TypeTable);
		OnChargeTableCorres(CodeTypeTable, 'EVT');
		Success("Chargement de la table corespondance Ok!! Le Type de Table utiliser pour cet vnement est: "..TypeTable);
	end
	
end
	
-- fonction qui enregistre le modif de la table de corespondance manuel
function OnSaveTableCorres()
	if TypeTable ~= 'ND' then
		cmd = "Delete From tagID_Correspondance Where Code_evenement = "..CodeTypeTable.." and TypeTable = '"..TypeTable.."'";
		RaceResult.dbSki:Query(cmd);
		
		local Grid_Ligne = dlgCorespondance:GetWindowName('grid_TableCorrespondance'):GetTable();
		-- Alert("RaceresultWebServeur_option:GetNbRows() = "..Grid_Ligne:GetNbRows());
		for i=0, Grid_Ligne:GetNbRows()-1 do
			TabletagID_Correspondance:SetCell("Code_evenement", i, Grid_Ligne:GetCellInt('Code_evenement', i));
			TabletagID_Correspondance:SetCell("TagID", i, Grid_Ligne:GetCell('TagID', i));
			TabletagID_Correspondance:SetCell("Dossard", i, Grid_Ligne:GetCellInt('Dossard', i));
			TabletagID_Correspondance:SetCell("TypeTable", i, TypeTable);
			RaceResult.dbSki:TableFlush(TabletagID_Correspondance, i);
		end
		Alert("Sauvegarde des lignes de la Table Correspondance ffectuer correctement"); 
	else
		Alert("Type de table non dfini sauvegarde des lignes Impossibles");
	end
end

-- Insertion d'une ligne de corespondance
function OnInsertLigneCor(evt)
	local grid_Cores = dlgCorespondance:GetWindowName('grid_TableCorrespondance');
	grid_Cores:InsertRows(grid_Cores:GetNumberRows());
	grid_Cores:SetGridCursor(grid_Cores:GetNumberRows()-1, 0);
end

-- Suppression d'une ligne de corespondance
function OnDeleteLigneCor(evt)
	local grid_Cores = dlgCorespondance:GetWindowName('grid_TableCorrespondance');
	local row = grid_Cores:GetGridCursorRow();
	if row >= 0 then
		grid_Cores:DeleteRows(row);
	end	
end

-- boite de dialogue pour la gestion de la table de corespondance
function OnOpenTableCorespondance(evt)
-- Cration Dialog 
	dlgCorespondance = wnd.CreateDialog({
		parent = RaceResult.panel,
		icon = "./res/32x32_ffs.png",
		label = 'Gestion des Tables de Corespondance',
		width = 500,
		height = 600
	});
	
	dlgCorespondance:LoadTemplateXML({ 
	xml = './device/raceresult.xml',
		node_name = 'root/panel',
		node_attr = 'name', 
		node_value = 'cores_Table'
	});

	
	Table = {};
	Race_table = {};
	function OnClosedlgCorespondance(evt)
		dlgCorespondance:EndModal();
	end
	
	-- Grid corespondance
	cmd = "Select * From tagID_Correspondance Where Code_evenement = '"..CodeTypeTable.."' Order by Dossard";
	RaceResult.dbSki:TableLoad(TabletagID_Correspondance, cmd)
	
	TabletagID_Correspondance:SetColumn('Code_evenement', { label = 'Code-Evt.', width = 12 });
	TabletagID_Correspondance:SetColumn('Dossard', { label = 'Dossard.', width = 12 });
	TabletagID_Correspondance:SetColumn('TagID', { label = 'TagID.', width = 12 });
	
	local grid = dlgCorespondance:GetWindowName('grid_TableCorrespondance');
	grid:Set({
			table_base = TabletagID_Correspondance,
			columns = 'Code_evenement, TagID, Dossard',
			selection_mode = gridSelectionModes.CELLS,
			sortable = false,
			enable_editing = true
			});

	-- Initialisation des Controles
	Table.state = false;
	
	-- ToolBar
	Race_table.tb = dlgCorespondance:GetWindowName('tb');
	raceresultTb_Table = Race_table.tb:AddTool("Outil race Time", "./res/32x32_config.png", "outils",  itemKind.DROPDOWN);
	raceresultTb_Clear = Race_table.tb:AddTool('Remise  Zro des Donnes', './res/32x32_clear.png');
	Race_table.tb:AddStretchableSpace();
	raceresultTb_InsertLigne = Race_table.tb:AddTool("Ajouter une Ligne", "./res/32x32_list_add.png");
	Race_table.tb:AddSeparator();
	raceresultTb_DeleteLigne = Race_table.tb:AddTool("Supprimer une Ligne", "./res/32x32_list_remove.png");
	Race_table.tb:AddSeparator();
	raceresultTb_Save = Race_table.tb:AddTool("Enregistrer", "./res/32x32_save.png");
	Race_table.tb:AddSeparator();
	raceresultTb_Exit = Race_table.tb:AddTool("Quitter", "./res/32x32_exit.png");

	local menuSend =  menu.Create();
	menuSend:AppendSeparator();
	raceresultTb_Table_TableGe = menuSend:Append({label="Utilisation de la Table Generique  tout les vnements", image ="./res/32x32_time-admin.png"});
	menuSend:AppendSeparator();	
	-- raceresultTb_OnChargeTableCorres = menuSend:Append({label="Upload d'une Table Generique  tout les vnements", image ="./res/32x32_time-admin.png"});
	-- menuSend:AppendSeparator();
	raceresultTb_Table_TableEvt = menuSend:Append({label="Upload et utilisation d'une Table unique  un vnement", image ="./res/vpe32x32_search.png"});
	Race_table.tb:SetDropdownMenu(raceresultTb_Table:GetId(), menuSend);
	Race_table.tb:Realize();
	
	-- Prise des Evenements (Bind)
	dlgCorespondance:Bind(eventType.MENU, OnraceResultOutil);
	-- dlgCorespondance:Bind(eventType.MENU, OnChargeTableCorres, raceresultTb_OnChargeTableCorres);
	dlgCorespondance:Bind(eventType.MENU, OnClearTableCorres, raceresultTb_Clear);
	dlgCorespondance:Bind(eventType.MENU, OnInsertLigneCor, raceresultTb_InsertLigne);
	dlgCorespondance:Bind(eventType.MENU, OnDeleteLigneCor, raceresultTb_DeleteLigne);
	dlgCorespondance:Bind(eventType.MENU, OnValidTypeTableGen, raceresultTb_Table_TableGe);
	dlgCorespondance:Bind(eventType.MENU, OnValidTypeTableEvt, raceresultTb_Table_TableEvt);
	dlgCorespondance:Bind(eventType.MENU, OnSaveTableCorres, raceresultTb_Save);
	dlgCorespondance:Bind(eventType.MENU, OnClosedlgCorespondance, raceresultTb_Exit);

	-- permet de verifier et fixer les choses avt le showmodal ( faire obligatoirement)
	dlgCorespondance:Fit();

	-- Affichage Modal
	dlgCorespondance:ShowModal();
end	

	-- Gestion des options pour le nombre dtour par tranche de dos et la gestion du N de passage / au N de tour
	-- Gestion des systeme Actifs
		-- Insertion d'une option par plage de dos
function OnInsertTrDos(evt)
	local grid_Option = dlgOptionTable:GetWindowName('grid_Option');
	grid_Option:InsertRows(grid_Option:GetNumberRows());
	grid_Option:SetGridCursor(grid_Option:GetNumberRows()-1, 0);
end

		-- Suppression d'une Option
function OnRemoveTrDos(evt)
	local grid_Option = dlgOptionTable:GetWindowName('grid_Option');
	local row = grid_Option:GetGridCursorRow();
	if row >= 0 then
		grid_Option:DeleteRows(row);
	end	
end

		-- Insertion d'une Loop
function OnInsertLoop(evt)
	local grid_Param = dlgOptionTable:GetWindowName('grid_Param');
	grid_Param:InsertRows(grid_Param:GetNumberRows());
	grid_Param:SetGridCursor(grid_Param:GetNumberRows()-1, 0);
end

		-- Suppression d'une Epreuve
function OnRemoveLoop(evt)
	local grid_Param = dlgOptionTable:GetWindowName('grid_Param');
	local row = grid_Param:GetGridCursorRow();
	if row >= 0 then
		grid_Param:DeleteRows(row);
	end	
end

		-- sauvegarde des grid option
function OnSaveOption(evt)
	cmd = "Delete From Evenement_tagID_Tour Where Code_evenement = "..RaceResult.code_competition.." And AdresseIP = '"..ActiveID.."'";
	RaceResult.dbSki:Query(cmd);
	local grid_Ligne = dlgOptionTable:GetWindowName('grid_Option');
	
	local Grid_Ligne = grid_Ligne:GetTable();
	--Alert("raceresult_option:GetNbRows() = "..Grid_Ligne:GetNbRows());
	for i=0, Grid_Ligne:GetNbRows()-1 do
			--enregistrement de la grid option dans la table TabletagID_Tour			
			local Code = Grid_Ligne:GetCellInt('Code_evenement', i);
			local AdresseIP = Grid_Ligne:GetCell('AdresseIP', i);
			local Code_epreuve = tonumber(Grid_Ligne:GetCell('Code_epreuve', i));		
			local LoopID = Grid_Ligne:GetCell('LoopID', i);
			local LoopCanal = Grid_Ligne:GetCell('LoopCanal', i);
			local ID_1er_Inter = Grid_Ligne:GetCellInt('ID_1er_Inter', i);
			if i == 0 then
				Id_Passage = Grid_Ligne:GetCellInt('passage', i);
			end
			local passage = Grid_Ligne:GetCellInt('passage', i);
			local Tour = Grid_Ligne:GetCellInt('Tour', i);
			local Tps_Tour = Grid_Ligne:GetCellInt('Tps_Tour', i);
			local Tps_Tour_Pena = Grid_Ligne:GetCellInt('Tps_Tour_Pena', i);
		-- Alert("raceresult_option:GetNbRows() = "..Grid_Ligne:GetCell('LoopID', i));
		AddTabletagID_Tour(Code,AdresseIP,Code_epreuve,LoopID,LoopCanal,ID_1er_Inter,passage,Tour,Tps_Tour,Tps_Tour_Pena);
	end
		Alert("Sauvegarde des lignes ds Evenement_tagID_Tour ffectuer correctement");
	
	cmd = "Delete From Evenement_tagID_Passings Where Code_evenement = "..RaceResult.code_competition.." And AdresseIP = '"..ActiveID.."'";
	RaceResult.dbSki:Query(cmd);
	local grid_Param = dlgOptionTable:GetWindowName('grid_Param');
	local Grid_Param = grid_Param:GetTable();
	-- Alert("raceresult_option:GetNbRows() = "..Grid_Param:GetNbRows());
	for i=0, Grid_Param:GetNbRows()-1 do
		--enregistrement de la grid option dans la table TabletagID_Passings						
		local Code = Grid_Param:GetCellInt('Code_evenement', i);
		local AdresseIP = Grid_Param:GetCell('AdresseIP', i);
		local Port = Grid_Param:GetCell('Port', i);		
		local LoopID = Grid_Param:GetCell('LoopID', i);
		local LoopCanal = Grid_Param:GetCell('LoopCanal', i);
		local Passings = Grid_Param:GetCell('Passings', i);
		local TypeTable = Grid_Param:GetCell('TypeTable', i);
		local DelayDoubleDetect = Grid_Param:GetCellInt('DelayDoubleDetect', i);
		local CountTourActif = Grid_Param:GetCellInt('CountTourActif', i);
		local SystemeActif = Grid_Param:GetCellInt('SystemeActif', i);
		local Evt_multi_Jour = Grid_Param:GetCellInt('Evt_multi_Jour', i);
		if Evt_multi_Jour == 1 then
			RaceResult.prem_Jour_Evt = Grid_Param:GetCell('prem_Jour_Evt', i);
			RaceResult.Evt_multi_Jour = true;
			Warning("La gestion multi_Jour est Activ et le 1er jour de comptition est le: "..RaceResult.prem_Jour_Evt);
		end
		local prem_Jour_Evt = Grid_Param:GetCell('prem_Jour_Evt', i);
		AddTabletagID_Passings(Code,AdresseIP,Port,LoopID,LoopCanal,Passings,TypeTable,DelayDoubleDetect,CountTourActif,SystemeActif,Evt_multi_Jour,prem_Jour_Evt);	
	end
	Alert("Sauvegarde des lignes ds TabletagID_Passings ffectuer correctement");
	
	-- Mise  jour du numero de passage dans le caption de la boite de dialogue du device race result
	
	local caption = "Tableau de Bord Race Result IP: "..ActiveID..", Passage = "..Id_Passage;

	local mgr = app.GetAuiManager();
	mgr:SetCaption('panel_raceresult_'..ActiveID, caption); -- cosandco
	mgr:Update();
	-- Alert("passageapres onsaveconfig = "..Id_Passage);	
end

		-- boite de dialogue pour la gestions des options et des nb tours et N de passage	
function OnOpenOptions(evt)
-- Cration Dialog 

	dlgOptionTable = wnd.CreateDialog({
		parent = RaceResult.panel,
		icon = "./res/32x32_ffs.png",
		label = 'Gestion des Options Nb Tours et / Passage',
		width = 1050,
		height = 1000
	});
	
	dlgOptionTable:LoadTemplateXML({ 
	xml = './device/raceresult.xml',
		node_name = 'root/panel',
		node_attr = 'name', 
		node_value = 'Option_Table'
	});
	
	raceresult_option = {};
	raceresult_param = {};
	raceresult_Exit = {};
	
	function OnClosedlgOptionTable(evt)
		dlgOptionTable:EndModal();
	end
	
-- Grid Options
	cmd = "Select * From Evenement_tagID_Tour Where Code_evenement = '"..RaceResult.code_competition.."' and AdresseIP = '"..ActiveID.."' Order by Code_evenement, Code_epreuve";
	RaceResult.dbSki:TableLoad(TabletagID_Tour, cmd)
	local tTabletagID_Tour = RaceResult.dbSki:TableLoad(TabletagID_Tour, cmd)
	
	tTabletagID_Tour:SetColumn('Code_evenement', { label = 'Code-Evt.', width = 9 });
	tTabletagID_Tour:SetColumn('Code_epreuve', { label = 'Code preuve.', width = 9 });
	tTabletagID_Tour:SetColumn('AdresseIP', { label = 'AdresseIP.', width = 12 });
	tTabletagID_Tour:SetColumn('LoopID', { label = 'Loop.', width = 9 });
	tTabletagID_Tour:SetColumn('LoopCanal', { label = 'LoopCanal.', width = 9 });
	tTabletagID_Tour:SetColumn('ID_1er_Inter', { label = 'ID 1er Inter.', width = 9 });
	tTabletagID_Tour:SetColumn('passage', { label = 'passage.', width = 9 });
	tTabletagID_Tour:SetColumn('Tour', { label = 'Tour.', width = 6 });
	tTabletagID_Tour:SetColumn('Tps_Tour', { label = 'Tps Tour.', width = 20 });
	tTabletagID_Tour:SetColumn('Tps_Tour_Pena', { label = 'Tps Tour Pena.', width = 20 });
	
	local grid_Option = dlgOptionTable:GetWindowName('grid_Option');
	grid_Option:Set({
		table_base = tTabletagID_Tour,
		columns = 'Code_evenement, Code_epreuve, AdresseIP, LoopID, LoopCanal, ID_1er_Inter, passage, Tour, Tps_Tour, Tps_Tour_Pena',
		selection_mode = gridSelectionModes.CELLS,
		sortable = false,
		enable_editing = true
	});
	
	grid_Option:SetColAttr('Tps_Tour', { kind='time' });
	grid_Option:SetColAttr('Tps_Tour_Pena', { kind='time' });

-- Initialisation des Controles

-- ToolBar OPTION
	raceresult_option.tb = dlgOptionTable:GetWindowName('tb_option');
	raceresultTb_InsertTrDos = raceresult_option.tb:AddTool("Ajouter une Ligne", "./res/32x32_list_add.png");
	raceresult_option.tb:AddStretchableSpace();
	raceresultTb_RemoveTrDos = raceresult_option.tb:AddTool("Supprimer une Ligne", "./res/32x32_list_remove.png");
	raceresult_option.tb:Realize();
-- Grid Parametre

	cmd = "Select * From Evenement_tagID_Passings Where Code_evenement = '"..RaceResult.code_competition.."' And AdresseIP = '"..ActiveID.."' Order by Code_evenement, LoopID, LoopCanal";
	local tTabletagID_Passings = RaceResult.dbSki:TableLoad(TabletagID_Passings, cmd)
	
	tTabletagID_Passings:SetColumn('Code_evenement', { label = 'Code-Evt.', width = 9 });
	tTabletagID_Passings:SetColumn('AdresseIP', { label = 'AdresseIP.', width = 12 });
	tTabletagID_Passings:SetColumn('Port', { label = 'Port.', width = 9 });
	tTabletagID_Passings:SetColumn('LoopID', { label = 'LoopID.', width = 6 });
	tTabletagID_Passings:SetColumn('LoopCanal', { label = 'LoopCanal.', width = 6 });
	tTabletagID_Passings:SetColumn('Passings', { label = 'Nb Passings.', width = 12 });
	tTabletagID_Passings:SetColumn('TypeTable', { label = 'TypeTable.', width = 9 });
	tTabletagID_Passings:SetColumn('DelayDoubleDetect', { label = 'Delai Double Detect.', width = 20 });
	tTabletagID_Passings:SetColumn('CountTourActif', { label = 'Compteur Tour Pena Actif.', width = 22 });
	tTabletagID_Passings:SetColumn('SystemeActif', { label = 'SystemeActif.', width = 22 });
	tTabletagID_Passings:SetColumn('Evt_multi_Jour', { label = 'Evt Multi Jour.', width = 22 });
	tTabletagID_Passings:SetColumn('prem_Jour_Evt', { label = '1er Jour de l\'Evt.', width = 22 });
	local gridParams = dlgOptionTable:GetWindowName('grid_Param');
	gridParams:Set({
		table_base = tTabletagID_Passings,
		columns = 'Code_evenement, AdresseIP, Port, LoopID, LoopCanal, Passings, TypeTable, DelayDoubleDetect, CountTourActif, SystemeActif, Evt_multi_Jour, prem_Jour_Evt',
		selection_mode = gridSelectionModes.CELLS,
		sortable = false,
		enable_editing = true
	});
	
	gridParams:SetColAttr('CountTourActif', { kind = 'bool', value_true = '1' });
	gridParams:SetColAttr('SystemeActif', { kind = 'bool', value_true = '1' });
	gridParams:SetColAttr('Evt_multi_Jour', { kind = 'bool', value_true = '1' });
	-- gridParams:SetColAttr('prem_Jour_Evt', { kind = 'bool', value_true = '1' });
	-- gridParams:SetColAttr('DelayDoubleDetect', { kind='time' });

-- Initialisation des Controles
		
	-- ToolBar PARAM
	raceresult_param.tb = dlgOptionTable:GetWindowName('tb_param');
	raceresultTb_InsertLoop = raceresult_param.tb:AddTool("Dupliquer une Ligne", "./res/32x32_list_add.png");
	raceresult_param.tb:AddStretchableSpace();
	raceresultTb_RemoveLoop = raceresult_param.tb:AddTool("Suprimer une Ligne", "./res/32x32_list_remove.png");
	raceresult_param.tb:Realize();
	
	-- ToolBar exit
	raceresult_Exit.tb = dlgOptionTable:GetWindowName('tb');
	raceresultTb_Save = raceresult_Exit.tb:AddTool("Enregistrer", "./res/32x32_save.png");
	raceresult_Exit.tb:AddStretchableSpace();
	raceresultTb_Exit = raceresult_Exit.tb:AddTool("Quitter", "./res/32x32_exit.png");
	raceresult_Exit.tb:Realize();
	
	-- Prise des Evenements (Bind)
	dlgOptionTable:Bind(eventType.MENU, OnInsertTrDos, raceresultTb_InsertTrDos);
	dlgOptionTable:Bind(eventType.MENU, OnRemoveTrDos, raceresultTb_RemoveTrDos);
	dlgOptionTable:Bind(eventType.MENU, OnInsertLoop, raceresultTb_InsertLoop);
	dlgOptionTable:Bind(eventType.MENU, OnRemoveLoop, raceresultTb_RemoveLoop);
	dlgOptionTable:Bind(eventType.MENU, OnSaveOption, raceresultTb_Save);
	dlgOptionTable:Bind(eventType.MENU, OnClosedlgOptionTable, raceresultTb_Exit);
	
	-- permet de verifier et fixer les choses avt le showmodal ( faire obligatoirement)
	dlgOptionTable:Fit();

	-- Affichage Modal
	dlgOptionTable:ShowModal();
end
	
	-- Gestion des tables Tag ID.....
		--fonction permetant de vider la table tagid finish de l'evenement
function OnDeleteTagIdFinish()
	if RaceResult.panel:MessageBox("Confirmation du supression des Tag_ID dj dtecter? \n\n Seul les TagID dtecter par le dcodeur ACTIF seront ffacer \n Attention lors de la prochaine detection \n les transpondeurs ne seront plus mis en double detection \n et les dossards deja arrivs passerons dans la colonne ancien dossard", " Supression des Tag_ID dj dtecter", msgBoxStyle.YES_NO+msgBoxStyle.ICON_INFORMATION) ~= msgBoxStyle.YES then
		return;
	end
	TabletagID_Finish = RaceResult.dbSki:GetTable('tagID_Finish');
--recherche du nombre de ligne ds la table tag ID et afichage
	cmd = "Select * From tagID_Finish Where Code_evenement = "..RaceResult.code_competition.." And AdresseIP = '"..ActiveID.."'";
	tTabletagID_Finish = RaceResult.dbSki:TableLoad(TabletagID_Finish,cmd);
	local nbTagID_Finish = tTabletagID_Finish:GetNbRows();
	Alert("Nb de tagID Dja inscrit dans la table : "..nbTagID_Finish.." de l'Evt N"..RaceResult.code_competition.." du decodeur:"..ActiveID)

--Vidage de la table
	cmd = "Delete From tagID_Finish Where Code_evenement = "..RaceResult.code_competition.." And AdresseIP = '"..ActiveID.."'";
	RaceResult.dbSki:Query(cmd);
	
	Warning("Vidage table TagID_Finish ok...");
--recherche du nombre de ligne ds la table tag ID et afichage pour verication	
	cmd = "Select * From tagID_Finish Where Code_evenement = "..RaceResult.code_competition.." And AdresseIP = '"..ActiveID.."'";	
	tTabletagID_Finish = RaceResult.dbSki:TableLoad(TableTagID_Finish,cmd);
	local nbTagID_Finish = tTabletagID_Finish:GetNbRows();
	Alert("Nb de tagID restant inscrit dans la table : "..nbTagID_Finish.." de l'Evt N"..RaceResult.code_competition.." du decodeur:"..ActiveID)

end

--fonction permetant de vider la table tagid Tour de l'evenement
function OnDeleteTagIdTourPena()
	if RaceResult.panel:MessageBox("Confirmation du supression des Nb de Tours ? \n\n Attention cette Opration effaceras le Nb de tour  \n la Table de donnes comportants  \n le Nb de tour d Pnalite ffectue", " Supression du Nb de tours ffectuer", msgBoxStyle.YES_NO+msgBoxStyle.ICON_INFORMATION) ~= msgBoxStyle.YES then
		return;
	end
	TabletagID_TourPena = RaceResult.dbSki:GetTable('tagID_TourPena');
	
--recherche du nombre de ligne ds la table tag ID et afichage
	cmd = "Select * From tagID_TourPena Where Code_evenement = "..RaceResult.code_competition;
	tTabletagID_TourPena = RaceResult.dbSki:TableLoad(TabletagID_TourPena,cmd);
	local nbtagID_TourPena = tTabletagID_TourPena:GetNbRows();
	-- Alert("nbtagID_TourPena"..nbtagID_TourPena)
	if nbtagID_TourPena ~= 0 then
		Alert("Nb de Tour Dja inscrit dans la table : "..nbtagID_TourPena.." de l'Evt N"..RaceResult.code_competition)

--Vidage de la table
		cmd = "Delete From tagID_TourPena Where Code_evenement = "..RaceResult.code_competition;
		RaceResult.dbSki:Query(cmd);
		
		Warning("Vidage table tagID_TourPena ok...");
	
--recherche du nombre de ligne ds la table tag ID et afichage pour verication	
		cmd = "Select * From tagID_TourPena Where Code_evenement = "..RaceResult.code_competition;	
		tTabletagID_TourPena = RaceResult.dbSki:TableLoad(TabletagID_TourPena,cmd);
		local nbTagID_Finish = tTabletagID_TourPena:GetNbRows();
		Alert("Nb de tagID restant inscrit dans la table : "..nbTagID_Finish.." de l'Evt N"..RaceResult.code_competition.."")
	else
		Alert("Pas de Dossard inscrit dans la table tagID_TourPena pour l\'vnement N"..RaceResult.code_competition.."")
	end 
end	
	
		-- insertion d'une ligne dans la table TabletagID_Tour
function AddTabletagID_Tour(Code,AdresseIP,Code_epreuve,LoopID,LoopCanal,ID_1er_Inter,passage,Tour,Tps_Tour,Tps_Tour_Pena)
	local r = TabletagID_Tour:AddRow();
	TabletagID_Tour:SetCell("Code_evenement", r, tonumber(Code));
	TabletagID_Tour:SetCell("AdresseIP", r, AdresseIP);
	TabletagID_Tour:SetCell("Code_epreuve", r, tonumber(Code_epreuve));		
	TabletagID_Tour:SetCell("LoopID", r, LoopID);
	TabletagID_Tour:SetCell("LoopCanal", r, LoopCanal);
	TabletagID_Tour:SetCell("ID_1er_Inter", r, tonumber(ID_1er_Inter));
	TabletagID_Tour:SetCell("passage", r, tonumber(passage));
	TabletagID_Tour:SetCell("Tour", r, tonumber(Tour));
	TabletagID_Tour:SetCell("Tps_Tour", r, tonumber(Tps_Tour) or 0);
	TabletagID_Tour:SetCell("Tps_Tour_Pena", r, tonumber(Tps_Tour_Pena) or 0);
	RaceResult.dbSki:TableFlush(TabletagID_Tour, r);
end 

		-- insertion d'une ligne dans la table TabletagID_Passings
function AddTabletagID_Passings(Code,AdresseIP,ActivePort,LoopID,LoopCanal,Passings,TypeTable,DelayDoubleDetect,CountTourActif,SystemeActif,Evt_multi_Jour,prem_Jour_Evt);			
	local r = TabletagID_Passings:AddRow();				
	TabletagID_Passings:SetCell("Code_evenement", r, tonumber(Code));
	TabletagID_Passings:SetCell("AdresseIP", r, ActiveID);
	TabletagID_Passings:SetCell("Port", r, tonumber(ActivePort));
	TabletagID_Passings:SetCell("LoopID", r, LoopID);
	TabletagID_Passings:SetCell("LoopCanal", r, LoopCanal);
	TabletagID_Passings:SetCell("Passings", r, tonumber(Passings));
	TabletagID_Passings:SetCell("TypeTable", r, TypeTable);
	TabletagID_Passings:SetCell("DelayDoubleDetect", r, DelayDoubleDetect);
	TabletagID_Passings:SetCell("CountTourActif", r, tonumber(CountTourActif));
	TabletagID_Passings:SetCell("SystemeActif", r, tonumber(SystemeActif));
	TabletagID_Passings:SetCell("Evt_multi_Jour", r, tonumber(Evt_multi_Jour));
	TabletagID_Passings:SetCell("prem_Jour_Evt", r, tostring(prem_Jour_Evt));
	RaceResult.dbSki:TableFlush(TabletagID_Passings, r);
end
		-- fonction permettant de remetre  zro le nb de passing sur l'evenement
function OnClearPassing()
--Alert("ActiveID :"..ActiveID);
	local NbPassing = '';
	if RaceResult.panel:MessageBox("Confirmation du supression des Nb de passings dj dtecter? \n\n Attention cette pration vas remetre le compteur de dtection  zro\n SKIFFS vas aller rcuperer toutes les detections du dcodeur ", " Remise  zro du Nb de dtection", msgBoxStyle.YES_NO+msgBoxStyle.ICON_INFORMATION) ~= msgBoxStyle.YES then
		return;
	end
	SavePassingCurrent(0);
end

--  finir
function OnRunErased(key, params)
	Alert("Suppression de tous les passages !!!!!! : on doit faire des trucs ...");
	return true;
end

-- fontion permetant d'avoir les info du bibload
function OnBibLoaded(key, params)
	if type(params.table) == 'userdata' then
		Alert(params.table:GetCell("Dossard",0).." "..params.table:GetCell("Nom",0).." "..params.table:GetCell("Prenom",0));
	end
	return true;
end

-- Menu outil
	--fonction qui permet de verifier que le protocol est mis en place et que le decodeur repond par pong si tt est ok
function OnPing(evt)
	local sockClient = mt_device.obj;
	if sockClient ~= nil then
		sockClient:WriteString("PING");
		sockClient:WriteByte(asciiCode.CR, asciiCode.LF);
		Warning('PING Envoy ...');
	else
		Warning('Connection perdu ...');
	end
end

	-- renvoi le mode de fonctionnement du decodeur test ou chrono
function OnMode(evt)
	local sockClient = mt_device.obj;
	if sockClient ~= nil then
		sockClient:WriteString("GETMODE");
		sockClient:WriteByte(asciiCode.CR, asciiCode.LF);
	else
		Warning('Connection perdu ...');
	end
end

	-- renvoi le N de protocol qu'utilise le decodeur
function OnProtocol(evt)
	local sockClient = mt_device.obj;
	if sockClient ~= nil then
		sockClient:WriteString("GETPROTOCOL");
		sockClient:WriteByte(asciiCode.CR, asciiCode.LF);
	else
		Warning('Connection perdu ...');
	end
end

	--renvoi le status du decodeur
function OnStatus(evt)
	local sockClient = mt_device.obj;
	if sockClient ~= nil then
		sockClient:WriteString("GETSTATUS");
		sockClient:WriteByte(asciiCode.CR, asciiCode.LF);
		RaceResult.GetStatus = "Ok" ;
		Alert ('Envoi GetStatus'..RaceResult.GetStatus);
		return RaceResult.GetStatus
	else
		Warning('Connection perdu ...');
	end
end

	--renvoi le Nb de passings enregistrer dans le fichier du decodeur
function OnPassings(evt, Get)
	local sockClient = mt_device.obj;
	if sockClient ~= nil then
		sockClient:WriteString("PASSINGS");
		sockClient:WriteByte(asciiCode.CR, asciiCode.LF);
		Alert("Nb de Passing ds le fichier du decodeur = "..RaceResult.RecordsCount);
	else
		Warning('Connection perdu ...');
	end
end

	--renvoi le temps tournant du decodeur
function OnGetTime(evt)
	local sockClient = mt_device.obj;
	if sockClient ~= nil then
		sockClient:WriteString("GETTIME");
		sockClient:WriteByte(asciiCode.CR, asciiCode.LF);
	else
		Warning('Connection perdu ...');
	end
end

	-- renvoi le niveau de charge du decodeur
function OnChargeBat(evt)
	local sockClient = mt_device.obj;
	if sockClient ~= nil then
		sockClient:WriteString("GETSTATUS");
		sockClient:WriteByte(asciiCode.CR, asciiCode.LF);
	else
		Warning('Connection perdu ...');
	end
end

	-- Synchronisation du l'heure GPS SETGPSTIME
function OnStartGPS_Time(evt)
	local sockClient = mt_device.obj;
	if sockClient ~= nil then
		sockClient:WriteString("SETGPSTIME");
		sockClient:WriteByte(asciiCode.CR, asciiCode.LF);
		Warning('Synchronisation de l\'heure GPS envoy ...');
	else
		Warning('Connection perdu ...');
	end
end	
	
	-- active la fonction chrono du decodeur a distance
function OnStartOperation(evt)
	local sockClient = mt_device.obj;
	if sockClient ~= nil then
		sockClient:WriteString("STARTOPERATION");
		sockClient:WriteByte(asciiCode.CR, asciiCode.LF);
		Warning('Demande d\'Activation des antennes envoy ...');
	else
		Warning('Connection perdu ...');
	end
end

	-- met le chrono en stanby
function OnStopOperation(evt)
	local sockClient = mt_device.obj;
	if sockClient ~= nil then
		sockClient:WriteString("STOPOPERATION");
		sockClient:WriteByte(asciiCode.CR, asciiCode.LF);
		Warning('Demande de dsactivation des antennes envoy ...');
	else
		Warning('Connection perdu ...');
	end
end

	-- Met l'upload en marche
function OnStartUpload(evt)
	local sockClient = mt_device.obj;
	if sockClient ~= nil then
		sockClient:WriteString("STARTUPLOAD");
		sockClient:WriteByte(asciiCode.CR, asciiCode.LF);
		Warning('Demande d\'Activation des antennes envoy ...');
	else
		Warning('Connection perdu ...');
	end
end

	-- arrete l'upload
function OnStopUpload(evt)
	local sockClient = mt_device.obj;
	if sockClient ~= nil then
		sockClient:WriteString("STOPUPLOAD");
		sockClient:WriteByte(asciiCode.CR, asciiCode.LF);
		Warning('Demande d\'Activation des antennes envoy ...');
	else
		Warning('Connection perdu ...');
	end
end

function OnRechargeTagId(evt)
	Alert ('en cours de rdaction utiliser la fonction remise a zero di Nb passing');
end

--fonction de read packet
	-- outils
		-- fonction d'enregistrement du nombre de passings lu
function SavePassingCurrent(value)
	-- Prise de la Valeur en Mmoire 
	RaceResult.passingCurrent = value;
	-- Enregistrement en MySQL 
	cmd = 
		"Update Evenement_tagID_Passings set Passings = "..
		tostring(RaceResult.passingCurrent)..
		" Where Code_evenement = "..RaceResult.code_competition..
		" And AdresseIP = '"..ActiveID..
		"'"
		;
	RaceResult.dbSki:Query(cmd);
	cmd = "Select * From Evenement_tagID_Passings Where Code_evenement = "..RaceResult.code_competition.." and AdresseIP = '"..ActiveID.."'";
		TableTagID_Passings = RaceResult.dbSki:GetTable('Evenement_tagID_Passings');
		RaceResult.dbSki:TableLoad(TableTagID_Passings, cmd);	
	-- Alert("Nb de detection enregistre = "..TableTagID_Passings:GetCellInt('Passings', 0))
end

		-- fonction pour donner l'heure de detection au bon format .000
function GethourPassage(RealTime)
	-- Alert("	RealTime :"..RealTime);
	local a = string.find(RealTime, 'T') or 0;
	local b = string.find(RealTime, 'Z') or 0;
	local c = string.find(RealTime, '+') or 0;
	if c ~= 0 then 
	e = c 
	else 
	e = b 
	end
	-- Alert("	Debut trame :"..a.."fin de trame trackbox = "..b.." fin de trame decoder = "..c);
	local hourPassage = string.sub(RealTime, a+1, e-1);
	-- Alert("	hourPassage :"..hourPassage..' hourPassage:len() '..hourPassage:len());
	if hourPassage:len() == 8 then
		hourPassage = hourPassage..'.000'
	elseif hourPassage:len() == 9 then
		hourPassage = hourPassage..'000'
	elseif hourPassage:len() == 10 then
		hourPassage = hourPassage..'00'
	elseif hourPassage:len() == 11 then
		hourPassage = hourPassage..'0'
	end
	return hourPassage;
end

		-- format hh:mm:ss.kkk
function GetChrono(hourPassage, Nb_JourDecodeur)
	-- 1jr = 86400000ms
	local hour = string.sub(hourPassage,1,2);
	local minute = string.sub(hourPassage,4,5);
	local sec = string.sub(hourPassage,7,8);
	local milli = string.sub(hourPassage,10,12);
	return 3600000*tonumber(hour)+60000*tonumber(minute)+1000*tonumber(sec)+tonumber(milli)+tonumber(Nb_JourDecodeur)*86400000;
	-- a decommenter pour lire un fichier sav d'une track box et mettre en commentaire les deux lignes au dessus
	-- local milli = string.sub(hourPassage,10,10)..'00';
	-- return 3600000*tonumber(hour)+1000*tonumber(RaceResult.DiffGMT)+60000*tonumber(minute)+1000*tonumber(sec)+tonumber(milli);
end

		-- fonction pour donner le nb de jour si on gere un Evt sur plusieur jour
function GetNb_JourDecodeur(DecodeurDate, DateJour)
	Alert("DecodeurDate: "..DecodeurDate);
	Alert("DateJour: "..DateJour);
	if RaceResult.Evt_multi_Jour == true then
		-- local DateJour = os.date("%Y-%m-%d");
		-- local day = tonumber(os.date("%d"));
		-- local month = tonumber(os.date("%m"));
		-- local year = tonumber(os.date("%Y"));
		local day = tonumber(string.sub(DateJour,1,2));
		local month = tonumber(string.sub(DateJour,4,5));
		local year = tonumber(string.sub(DateJour,7,10));
		-- Alert("Date jour : "..day..' / '..month..' - '..year);
		local Dec_Jour = tonumber(string.sub(DecodeurDate,9,10));
		local Dec_mois = tonumber(string.sub(DecodeurDate,6,7));
		local Dec_Annee = tonumber(string.sub(DecodeurDate,1,4));
		-- Alert("Dec_Date: "..Dec_Jour..' / '..Dec_mois..' - '..Dec_Annee);
			
		if year == Dec_Annee and month == Dec_mois then
			-- Alert("Dec_Annee == year and Dec_mois == month");
			nbjour = Dec_Jour - day;
		elseif year == Dec_Annee and month ~= Dec_mois then
			-- Alert("Dec_Annee == year and Dec_mois ~= month");
			-- Alert("month = "..month);
			-- Alert("Dec_mois = "..Dec_mois);
			if tonumber(month)+1 == tonumber(Dec_mois) then 		-- si le decodeur a 1 mois de plus que le 1er jour de la compet
			-- Alert("month = tonumber(Dec_mois)+1");
				if month ~= 2 then -- si le mois n'est pas fvrier
					Alert("month ~= 2");
					local t = {1, 3, 5, 7, 8, 10, 12};
					for month in ipairs(t) do
							nb_jr_moisPrec = 31 - day
							-- Alert("mois a 31 jours")
					end
					local t1 = {4, 6, 9, 11};
					for month in pairs(t1) do
						-- Alert("mois a 30 jours")
						nb_jr_moisPrec = 30 - day
					end
					-- Alert("nb_jr_moisPrec"..nb_jr_moisPrec);
				else
					-- Alert("month fevrier special");
					-- local year = os.date("%Y");
					if year % 400 == 0 or (year % 4 == 0 and year % 100 ~= 0) then
						nb_jr_moisPrec = 29 - day
					else
						nb_jr_moisPrec = 28 - day
					end
				end
				nbjour = nb_jr_moisPrec + Dec_Jour;
			else
				nbjour = 0;
			end
		else
			nbjour = 0;
		end
	else
		nbjour = 0;
	end
	-- Alert("nbjour = "..nbjour);
	return tonumber(nbjour);
end

-- fonction qui renvoi Le N de passage du concurents suivant le nb de tour a faire et le nb de tour deja raliser
function GetPassage(NbToursAFaire, NbTourRealiser, bib);
	local CodeEpreuve_bib = GetCodeEpreuve(bib);
	-- Alert("le bib dans GetPassage est = "..bib.." avec le code preuve : "..CodeEpreuve_bib);
	cmd = "Select * From Evenement_tagID_Tour Where Code_evenement = "..RaceResult.code_competition..
								  " and AdresseIP = '"..ActiveID..
								  " ' and Code_epreuve = "..CodeEpreuve_bib..
								  " and LoopID = '"..LoopID..
								  "' and LoopCanal = '"..LoopCanal..
								  "'"
								  ;
	-- Alert('cmd = '..cmd);
	TabletagID_Tour = RaceResult.dbSki:GetTable('Evenement_tagID_Tour');
	local tTabletagID_Tour  = RaceResult.dbSki:TableLoad(TabletagID_Tour, cmd);							  
	Alert('tTabletagID_Tour:GetNbRows() = '..tTabletagID_Tour:GetNbRows());
	-- suivant le nombre de tour fait par le concurent et le nombre de tour qu'il a a faire j'acremente la variable passage
	-- si le concurent n'a pas fait plus le nombre de tour alors passage seras egal NbTourRealiser
	if NbToursAFaire == 0 then
		return tTabletagID_Tour:GetCellInt('passage', 0);
		-- Alert("if tonumber(NbToursAFaire) == 0 : "..passage);
	elseif NbToursAFaire == -1 then
		return tTabletagID_Tour:GetCellInt('passage', 0);
	else
		if NbTourRealiser < NbToursAFaire then 
			return NbTourRealiser + ID_1er_Inter;
			--Alert("if tonumber(NbTourRealiser) < tonumber(NbToursAFaire) : "..passage);
		--si le concurent a fait le nombre de tour alors passage seras egal a passage	
		elseif	NbTourRealiser == NbToursAFaire then 
			return tTabletagID_Tour:GetCellInt('passage', 0);
			--Alert("if tonumber(NbTourRealiser) == tonumber(NbToursAFaire) : "..passage);
		--si le concurent a fait plus que le nombre de tour alors passage seras egal a passage 
		elseif NbTourRealiser > tonumber(NbToursAFaire) then
			--Alert("tonumber(NbTourRealiser) > tonumber(NbToursAFaire) : "..passage);
			return tTabletagID_Tour:GetCellInt('passage', 0);
		end
	end
end

-- fonction qui renvoi le Nb de tour raliser par le concurent
function GetNbTourRealiser(tagID)
	-- recherche du nombre de tour fait par le coureur ds la Table TableTagID_Finish 
	cmd = "select * from tagID_Finish Where Code_evenement = "..RaceResult.code_competition..
			" and AdresseIP = '"..ActiveID..
			"' and LoopID = '"..LoopID..
			"' and LoopCanal = '"..LoopCanal..
			"' and TagID = '"..tagID..
			"'"
	return RaceResult.dbSki:TableLoad(TableTagID_Finish, cmd):GetCellInt("Tour", 0);
end 

-- function qui Recherche du delay de double detection
function GetDelayDoubleDetect()		
	-- Chargement de la table TableTagID_Passings pour avoir le DelayDoubleDetect
	cmd = "Select * From Evenement_tagID_Passings Where Code_evenement = "..RaceResult.code_competition..
		  " and AdresseIP = '"..ActiveID..
		  "' and LoopID = '"..LoopID..
		  "' and LoopCanal = '"..LoopCanal..
		  "'"
		  ;
	-- Race_result.dbSki:TableLoad(TableTagID_Passings, cmd);
	if tonumber(RaceResult.dbSki:TableLoad(TableTagID_Passings, cmd):GetNbRows()) == 0 then
		Warning(" Vrifier les numero des Loop et Canal Loop il doive etre: ");
		Alert("Les donnes du fichier lu sont -> LoopID = "..LoopID.." / Canal = "..LoopCanal.." / SystemeActif = "..SystemeActif )
		Warning(" Apres les avoir Vrifier recharger a nouveau le fichier ou ractiver la lecture du decodeur");
		Alert(" bien remetre le Nb de passing detecter  0 sinon le fichier ne seras pas lu");
		return false
	end
	
	return TableTagID_Passings:GetCell('DelayDoubleDetect', 0);
end

-- fonction de recherche du dos, du nombre de tour, de ID_1er_Inter, du passage par rapport au tag-id
function RecherchetourDos(CodeTypeTable,tagID,LoopID,LoopCanal)
-- recherche du dossard par rapport au TagID ds la table tagID_Correspondance
	cmd = "Select * From tagID_Correspondance Where Code_evenement = "..CodeTypeTable.." And TagID = '"..tagID.."'"; 
	tcorrespondance = RaceResult.dbSki:TableLoad(TabletagID_Correspondance, cmd);
	-- Alert("tcorrespondance:GetNbRows().."..tcorrespondance:GetNbRows());
	if tcorrespondance:GetNbRows() >=1 then
		bib = tcorrespondance:GetCellInt('Dossard',0);
		CodeEpreuve_bib = GetCodeEpreuve(bib);
		if CodeEpreuve_bib ~= -1 then
			-- Alert("le bib dans tcorrespondance est = "..bib.." avec le code preuve : "..CodeEpreuve_bib);
			-- on vas chercher le nombre de tour que le dos doit faire 
			if CodeEpreuve_bib ~= nil then				
				-- Alert("le bib dans tcorrespondance est = "..bib.." avec le code preuve : "..CodeEpreuve_bib);
				cmd = "Select * From Evenement_tagID_Tour Where Code_evenement = "..RaceResult.code_competition..
															 " And AdresseIP = '"..ActiveID..
															 "' And LoopID = '"..LoopID..
															 "' And LoopCanal = '"..LoopCanal..
															 "' And Code_epreuve = "..CodeEpreuve_bib;											 
				TabletagID_Tour = RaceResult.dbSki:GetTable('Evenement_tagID_Tour');
				local tTabletagID_Tour  = RaceResult.dbSki:TableLoad(TabletagID_Tour, cmd);
				-- Testnbtour = RaceResult.dbSki:TableLoad(TabletagID_Tour, cmd):GetNbRows();
				-- Alert("Testnbtour = "..Testnbtour);
				for i=0, tTabletagID_Tour:GetNbRows()-1 do 
				local Bib_CodeEpreuve = TabletagID_Tour:GetCellInt('Code_epreuve', i);
					if Bib_CodeEpreuve == CodeEpreuve_bib then
						NbToursAFaire = TabletagID_Tour:GetCellInt('Tour', i);
						passage = TabletagID_Tour:GetCellInt('passage', i);
						ID_1er_Inter = TabletagID_Tour:GetCellInt('ID_1er_Inter', i);
						if tonumber(CountTourActif) == 1 then
							Tps_Tour = TabletagID_Tour:GetCellInt('Tps_Tour', i);
							Tps_Tour_Pena = TabletagID_Tour:GetCellInt('Tps_Tour_Pena', i);
						end
						-- Alert("je suis dans la bonne ligne"..NbToursAFaire);
					end	
				end	
			else
				bib = '';
				NbToursAFaire = 0;
				ID_1er_Inter = -1;
				passage = Id_Passage;
			end
		else
			bib = bib;
			NbToursAFaire = 0;
			ID_1er_Inter = -1;
			passage = Id_Passage;
		end
	else 
		bib = '';
		NbToursAFaire = 0;
		ID_1er_Inter = -1;
		passage = Id_Passage;
	end 
end 

-- Pour la Gestion des Tour de Pnalit
-- fonction qui renvoi si le count tour est actif ou pas 
function RechercheCountTourActif(CodeTypeTable,tagID, LoopID,LoopCanal);
	-- recherche du dossard par rapport au TagID ds la table tagID_Correspondance
	cmd = "Select * From Evenement_tagID_Passings Where Code_evenement = "..RaceResult.code_competition..
												 " And AdresseIP = '"..ActiveID..
												 "' And LoopID = '"..LoopID..
												 "' And LoopCanal = '"..LoopCanal..
												 "'";
	CountTourActif = RaceResult.dbSki:TableLoad(TabletagID_Passings, cmd):GetCellInt("CountTourActif", 0);
	-- if CountTourActif == '' then 
		-- CountTourActif = 0 
	-- end
	Alert("cmd = "..cmd);
	Alert("CountTourActif = "..CountTourActif);
end

		-- fonction qui permet de mettre a jour le Nb tour dans la table tagID_finish
function AddNbTours(NbTours, tagID, ActiveID, LoopID, LoopCanal)
	--Alert("AddNbtours LoopID = "..ActiveID);
	local cmd = 
		"Update tagID_Finish SET Tour = "..NbTours..
		" Where Code_evenement = "..RaceResult.code_competition..
		" And AdresseIP = '"..ActiveID..
		"' And LoopID = '"..LoopID..
		"' And LoopCanal = '"..LoopCanal..
		"' And TagID = '"..tagID..
		"'"
	RaceResult.dbSki:Query(cmd);
	Success("mise a jour du nb tour au tagID ="..tagID.. " dans la tagID_Finish Donc :"..NbTours);
end

		-- fonction qui insert un tour de pena dans la table tagid pena
function InsertNbTour_Pena( ActiveID, LoopID, LoopCanal, bib, First_Tir, NbTour_Fait, Total_TrPena, chrono)
	 --Alert("Num_Tir = "..Num_Tir);	
 local r = TabletagID_TourPena:AddRow();				
				TabletagID_TourPena:SetCell("Code_evenement", r, tonumber(RaceResult.code_competition));
				TabletagID_TourPena:SetCell("AdresseIP", r, ActiveID);
				TabletagID_TourPena:SetCell("LoopID", r, LoopID);
				TabletagID_TourPena:SetCell("LoopCanal", r, LoopCanal);
				TabletagID_TourPena:SetCell("Dossard", r, bib);
				TabletagID_TourPena:SetCell("Tir1", r, tonumber(NbTour_Fait));	
				TabletagID_TourPena:SetCell("Tir2", r, 0);
				TabletagID_TourPena:SetCell("Tir3", r, 0);
				TabletagID_TourPena:SetCell("Tir4", r, 0);
				TabletagID_TourPena:SetCell("Tir5", r, 0);
				TabletagID_TourPena:SetCell("Tir6", r, 0);
				TabletagID_TourPena:SetCell("Tir7", r, 0);
				TabletagID_TourPena:SetCell("Tir8", r, 0);
				TabletagID_TourPena:SetCell("Tir9", r, 0);
				TabletagID_TourPena:SetCell("Tir10", r, 0);
				TabletagID_TourPena:SetCell("Num_Tir", r, tonumber(First_Tir));
				TabletagID_TourPena:SetCell("Total_TrPena", r, tonumber(Total_TrPena));
				TabletagID_TourPena:SetCell("Chrono", r, tonumber(chrono));
				RaceResult.dbSki:TableInsert(TabletagID_TourPena, r);
				Success("Ajout dos ="..bib.. " dans la TabletagID_TourPena");	
end

function GetFirst_Tir(ActiveID, LoopID, LoopCanal, bib, chrono)
	return 1;
end

function GetNum_Tir(ActiveID, LoopID, LoopCanal, bib, Bib_Chrono, Tps_Tour, Tps_Tour_Pena)
	TabletagID_TourPena = RaceResult.dbSki:GetTable('tagID_TourPena');
	cmd = "Select * From tagID_TourPena Where Code_evenement = '"..RaceResult.code_competition..
		  "' And AdresseIP = '"..ActiveID..
		  "' And LoopID = '"..LoopID..
		  "' And LoopCanal = '"..LoopCanal..
		  "' And Dossard = "..bib							 
		  ;
	tTabletagID_TourPena = RaceResult.dbSki:TableLoad(TabletagID_TourPena, cmd)
	-- Alert("tTabletagID_TourPena:GetNbRows() = "..tTabletagID_TourPena:GetNbRows());
	Num_Tir_Bib = tTabletagID_TourPena:GetCellInt('Num_Tir', 0);
	Chrono = tTabletagID_TourPena:GetCellInt('Chrono', 0);
	
	local TpsMini = tonumber(Chrono)+tonumber(Tps_Tour_Pena);
	local TpsMax = tonumber(Chrono)+tonumber(Tps_Tour);
	local TpsMax2 = tonumber(TpsMax)+tonumber(Tps_Tour);
	local TpsMax3 = tonumber(TpsMax2)+tonumber(Tps_Tour);
	local TpsMax4 = tonumber(TpsMax3)+tonumber(Tps_Tour);
	local TpsMax5 = tonumber(TpsMax4)+tonumber(Tps_Tour);
	local TpsMax6 = tonumber(TpsMax5)+tonumber(Tps_Tour);
	
	if tonumber(Bib_Chrono) >= tonumber(TpsMini) and tonumber(Bib_Chrono) <= tonumber(TpsMax) then
		Alert("Bib_Chrono est compris entre TpsMini et le TpsMax");
		Tir = "Tir"..Num_Tir_Bib;
		Num_Tir = Num_Tir_Bib;
		Alert("Num_Tir = "..Num_Tir);
		Alert("Tir = "..Tir);
		NbTourPenaRealiser = tTabletagID_TourPena:GetCellInt("Tir"..Num_Tir_Bib, 0);
		Alert("NbTourPenaRealiser au "..Tir.."= "..NbTourPenaRealiser);
	elseif tonumber(Bib_Chrono) >= tonumber(TpsMax) and tonumber(Bib_Chrono) <= tonumber(TpsMax2) then
		Alert("Bib_Chrono est > au TpsMax < TpsMax2 ");
		Num_Tir = Num_Tir_Bib+1;
		Tir = "Tir"..Num_Tir
		Alert("Num_Tir = "..Num_Tir);
		Alert("Tir = "..Tir);
		NbTourPenaRealiser = tTabletagID_TourPena:GetCellInt(Tir, 0);
		Alert("NbTourPenaRealiser au "..Tir.."= "..NbTourPenaRealiser);
	elseif tonumber(Bib_Chrono) >= tonumber(TpsMax2) and tonumber(Bib_Chrono) >= tonumber(TpsMax3) then
		Alert("Bib_Chrono est > au TpsMax2 < TpsMax3 ");
		Tir = "Tir"..Num_Tir_Bib+2;
		Num_Tir = Num_Tir_Bib;
		Alert("Num_Tir = "..Num_Tir);
		Alert("Tir = "..Tir);
		NbTourPenaRealiser = tTabletagID_TourPena:GetCellInt("Tir"..Num_Tir_Bib, 0);
		Alert("NbTourPenaRealiser au "..Tir.."= "..NbTourPenaRealiser);	
	elseif tonumber(Bib_Chrono) >= tonumber(TpsMax3) and tonumber(Bib_Chrono) >= tonumber(TpsMax4) then
		Alert("Bib_Chrono est > au TpsMax3 < TpsMax4 ");
		Tir = "Tir"..Num_Tir_Bib+3;
		Num_Tir = Num_Tir_Bib;
		Alert("Num_Tir = "..Num_Tir);
		Alert("Tir = "..Tir);
		NbTourPenaRealiser = tTabletagID_TourPena:GetCellInt("Tir"..Num_Tir_Bib, 0);
		Alert("NbTourPenaRealiser au "..Tir.."= "..NbTourPenaRealiser);	
	elseif tonumber(Bib_Chrono) >= tonumber(TpsMax5) and tonumber(Bib_Chrono) >= tonumber(TpsMax6) then
		Alert("Bib_Chrono est > au TpsMax5 < TpsMax6 ");
		Tir = "Tir"..Num_Tir_Bib+4;
		Num_Tir = Num_Tir_Bib;
		Alert("Num_Tir = "..Num_Tir);
		Alert("Tir = "..Tir);
		NbTourPenaRealiser = tTabletagID_TourPena:GetCellInt("Tir"..Num_Tir_Bib, 0);
		Alert("NbTourPenaRealiser au "..Tir.."= "..NbTourPenaRealiser);	
	end
	Total_TrPena = tTabletagID_TourPena:GetCellInt('Total_TrPena', 0);
end

function GetInfo_Tir(ActiveID, LoopID, LoopCanal, bib, Bib_Chrono)
	local CodeEpreuve_bib = GetCodeEpreuve(bib);
	if CodeEpreuve_bib ~= nil then
		TabletagID_Tour = RaceResult.dbSki:GetTable('Evenement_tagID_Tour');
		cmd = "select * from Evenement_tagID_Tour where Code_evenement = "..RaceResult.code_competition..
			" And Code_epreuve = "..CodeEpreuve_bib
		local tEvenement_tagID_Tour = RaceResult.dbSki:TableLoad(TabletagID_Tour, cmd)
		Alert("tEvenement_tagID_Tour:GetNbRows() = "..tEvenement_tagID_Tour:GetNbRows());
		Tps_Tour = tEvenement_tagID_Tour:GetCellInt('Tps_Tour', 0);
		Tps_Tour_Pena = tEvenement_tagID_Tour:GetCellInt('Tps_Tour_Pena', 0);
		
	else
		Tps_Tour = 0;
		Tps_Tour_Pena = 0;
	end
	
	GetNum_Tir(ActiveID, LoopID, LoopCanal, bib, Bib_Chrono, Tps_Tour, Tps_Tour_Pena);
	Bib_Chrono = 0;
	-- Alert("Tir = "..Tir);
	-- Alert("Total_TrPena = "..Total_TrPena);
	-- Alert("NbTourPenaRealiser = "..NbTourPenaRealiser);
	-- Alert("tTabletagID_TourPena:GetNbRows() = "..tTabletagID_TourPena:GetNbRows());
end

-- fonction qui ajoute un tour de pena dans la table tagidpena
function AddNbTour_Pena(ActiveID, LoopID, LoopCanal, bib, Tir, NbTourPenaRealiser, Num_Tir, Total_TrPena, chrono);
       --AddNbTour_Pena(ActiveID, LoopID, LoopCanal, bib, Tir, NbTourPenaRealiser, Total_TrPena, Chrono)
	--Alert("AddNbtours_pena Num_Tir = "..Num_Tir);
	--Alert("AddNbtours LoopID = "..NbTourPenaRealiser);
	
	local cmd = 
		"Update tagID_TourPena SET "..Tir.." = "..NbTourPenaRealiser..
		", Num_Tir = "..Num_Tir..
		", Total_TrPena = "..Total_TrPena..
		", Chrono = "..chrono..
		" Where Code_evenement = "..RaceResult.code_competition..
		" And AdresseIP = '"..ActiveID..
		"' And LoopID = '"..LoopID..
		"' And LoopCanal = '"..LoopCanal..
		"' And Dossard = '"..bib..
		"' "
		;
	RaceResult.dbSki:Query(cmd);
	-- Alert("cmd = "..cmd);
	Success("Ajout d\' 1 tour au dos ="..bib.. " dans la TabletagID_TourPena Donc :"..NbTourPenaRealiser);		
end
	
		-- fonction qui insert un dos dans la table tagIDfinish
function AddTimesTagIDFinish(tagID, passage, LoopID, LoopCanal, Tour, bib)
	-- ecriture du TagID dans la table tagID_Finish
	local r = TableTagID_Finish:AddRow();				
	TableTagID_Finish:SetCell("Code_evenement", r, RaceResult.code_competition);
	TableTagID_Finish:SetCell("AdresseIP", r, ActiveID);
	TableTagID_Finish:SetCell("LoopID", r, LoopID);
	TableTagID_Finish:SetCell("LoopCanal", r, LoopCanal);
	TableTagID_Finish:SetCell("TagID", r, tagID);		
	TableTagID_Finish:SetCell("Passage", r, passage);
	TableTagID_Finish:SetCell("Tour", r, Tour);
	RaceResult.dbSki:TableInsert(TableTagID_Finish, r);
		Success("Ajout dos ="..bib.. " dans la TableTagID_Finish");	
end

-- mise a jour du N de passage lors d'une dtection
function refreshTagIDFinish(tagID, passage, LoopID, LoopCanal)
	local cmd = 
			"Update tagID_Finish SET Passage = '"..passage..
			" 'Where Code_evenement = "..RaceResult.code_competition..
			" And AdresseIP = '"..ActiveID..
			"' And LoopID = '"..LoopID..   
			"' And LoopCanal = '"..LoopCanal.. 
			"' And tagID = '"..tagID..
			"' "
			;
	RaceResult.dbSki:Query(cmd);
	Success("Mise a jour du N de passage :"..passage.." du TagID ="..tagID.. " dans la TableTagID_Finish");
end

		-- Fonction pour qui renvoi l'heure de passage					
function GetHeurePassage(dossard, passage)
	local cmd =
		" Select * From Resultat_Chrono Where Code_evenement = "..RaceResult.code_competition..
		" And Code_manche = "..RaceResult.code_manche..
		" And Id = "..passage..
		" And Dossard = "..dossard
	;
	tResultatChrono = RaceResult.dbSki:GetTable('Resultat_Chrono');
	RaceResult.dbSki:TableLoad(tResultatChrono, cmd);
	--Alert('RaceResult.code_competition = '..RaceResult.code_competition);
	--Alert('RaceResult.code_manche = '..RaceResult.code_manche);
	--Alert('idPassage = '..passage);
	--Alert('dossard = '..dossard);
	
	if tResultatChrono == nil then return -1 end
	if tResultatChrono:GetNbRows() == 0 then return -1 end
	
	-- Heure de passage existe ...	
	return tResultatChrono:GetCellInt('Heure',0);
end

		-- Fonction qui renvoi un tps net
function GetTempsNet(dossard)
	local heureDep = GetHeurePassage(dossard, 0);
	local heureArr = GetHeurePassage(dossard, -1);
	
	if heureArr > heureDep and heureDep >= 0 then
		return heureArr-heureDep;
	else
		return -1;
	end
end

		-- fonction qui renvoi untps net inter
function GetTempsNetInter(dossard, inter)

	local heureDep = GetHeurePassage(dossard, 0);
	local heureInter = GetHeurePassage(dossard, inter);
	
	if heureInter > heureDep and heureDep >= 0 then
		return heureInter-heureDep;
	else
		return -1;
	end
end

		-- fonction permetant d'aller chercher le nb de pena d'un dossard
function GetPenaBiathlon(dossard, passage)
	local dossard = 1;
	local Num_Tir = 3;
	local Code_coureur = GetCodecoureur(dossard);
	Alert('GetPenaBiathlon Code_coureur = '..Code_coureur);
	local cmd =
		" Select * From Resultat_Manche Where Code_evenement = "..RaceResult.code_competition..
		" And Code_coureur = '"..Code_coureur..
		"'"
	;
	tResultat_Manche = RaceResult.dbSki:GetTable('Resultat_Manche');
	RaceResult.dbSki:TableLoad(tResultat_Manche, cmd);
	--Alert('RaceResult.code_competition = '..RaceResult.code_competition);
	--Alert('RaceResult.code_manche = '..RaceResult.code_manche);
	--Alert('idPassage = '..passage);
	--Alert('dossard = '..dossard);
	
	if tResultat_Manche == nil then return -1 end
	if tResultat_Manche:GetNbRows() == 0 then return -1 end
	
	-- Heure de passage existe ...	
	--return tResultat:GetCellInt('Penalite',0);
	if Num_Tir == 1 then
	i = 1;
	elseif Num_Tir == 2 then
	i = 3;
	elseif Num_Tir == 3 then
	i = 5;
	elseif Num_Tir == 4 then
	i = 7;
	elseif Num_Tir == 5 then
	i = 9;
	elseif Num_Tir == 6 then
	i = 11;
	end
	Alert('pena tir biathlon = '..string.sub(tResultat_Manche:GetCell('Penalite',0),i,i));
end

		-- fonction permetant de trouver le Code coureur / au dos
function GetCodecoureur(dossard)
	local cmd =
		" select * From Resultat Where Code_evenement = "..RaceResult.code_competition..
		" And Dossard = "..dossard
	;
	tResultat = RaceResult.dbSki:GetTable('Resultat');
	RaceResult.dbSki:TableLoad(tResultat, cmd);
	--Alert('RaceResult.code_competition = '..RaceResult.code_competition);
	--Alert('RaceResult.code_manche = '..RaceResult.code_manche);
	--Alert('idPassage = '..passage);
	--Alert('dossard = '..dossard);
	
	if tResultat == nil then return -1 end
	if tResultat:GetNbRows() == 0 then return -1 end
	Alert('GetCodecoureur = '..tResultat:GetCell('Code_coureur',0));
	-- Heure de passage existe ...	
	return tResultat:GetCell('Code_coureur',0);
end

		-- fonction recherche si un tagID existe dans la table TableTagID_Finish et di ID du dernier passage
function RechercheTagId_Rech_Der_Passage_TagID(ActiveID, LoopID, LoopCanal, tagID)
	ImpulSynchro = 0;
	cmd = "Select * From tagID_Finish Where Code_evenement = '"..RaceResult.code_competition..
		  "' And AdresseIP = '"..ActiveID..
		  "' And LoopID = '"..LoopID..
		  "' And LoopCanal = '"..LoopCanal..
		  "' And TagID = '"..tagID..
		  "'"
		  ;
	
	tRech_TagID = RaceResult.dbSki:TableLoad(TableTagID_Finish, cmd);
	if tRech_TagID:GetNbRows() >= 1 then
		Rech_Der_Passage_TagID = tRech_TagID:GetCellInt("Passage", 0);
		Rech_TagID = tRech_TagID:GetCell("TagID", 0)
	else
		Rech_Der_Passage_TagID = '';
		Rech_TagID = ''; 
	end
	Alert('Rech_TagID = '..Rech_TagID..' And Rech_Der_Passage_TagID = '..Rech_Der_Passage_TagID);
end

-- recherche si un tagID existe dans la table TagID_TourPena
function rechercheDos_TabletagID_TourPena(ActiveID, LoopID, LoopCanal, bib)
	cmd = "Select * From tagID_TourPena Where Code_evenement = '"..RaceResult.code_competition..
		  "' And AdresseIP = '"..ActiveID..
		  "' And LoopID = '"..LoopID..
		  "' And LoopCanal = '"..LoopCanal..
		  "' And Dossard = "..bib							 
		  ;
	return RaceResult.dbSki:TableLoad(TabletagID_TourPena, cmd):GetCell("Dossard", 0);
end

-- Recherche du Code_Epreuve du concurent
function GetCodeEpreuve(bib)
	-- 1) bibLoad.ranking => sqlTable avec tous les champs de la table Ranking des Editions
	local rc, bibLoad = app.SendNotify("<bib_load>", { bib = bib });
	if rc and type(bibLoad) == 'table' then
		if bibLoad.ranking:GetNbRows() == 1 then
			return bibLoad.ranking:GetCellInt('Code_epreuve', 0);
		end
	end
	return -1;
end

-- Recherche de l'HeureDepart de l'preuve
function rechercheHeureDepartEpreuve(bib)
	local CodeEpreuve = GetCodeEpreuve(bib);
	tEpreuveGlobal = tEpreuveGlobal or nil;
	if tEpreuveGlobal == nil then
		local rc, raceInfo = app.SendNotify('<race_load>');
		tEpreuveGlobal = raceInfo.tables.Epreuve;
	end
	Alert("bib = "..bib);
	Alert("CodeEpreuve = "..CodeEpreuve);

	if CodeEpreuve >= 0 then
		for i=0, tEpreuveGlobal:GetNbRows()-1 do
			if tEpreuveGlobal:GetCellInt('Code_epreuve', i) == CodeEpreuve then
				-- Success("l\'HeureDepart de l\'preuve "..tostring(tEpreuveGlobal:GetCell('Heure_depart', i))..' ok ..');
				return tEpreuveGlobal:GetCellInt('Heure_depart', i);
			end
		end
		-- Alert(" heureDepart de l epreuve "..tostring(tEpreuveGlobal:GetCell('Heure_depart', CodeEpreuve-1))..' ok ..');
	end	
	return -1;
end

-- Recherche de l'Heure de passage du concurent
function rechercheHeurePassageBib(bib, idPassage)
	-- 2) bibLoad.passage = sqlTable idem struture Resultat_Chrono
	idPassage = tonumber(idPassage);
	-- 0 = Dpart, -1 = Arrive, 1 = Inter 1, 2 = Inter 2 ... Resultat_Chrono.Id
	local rc, bibLoad = app.SendNotify("<bib_load>", { bib = bib });
	if rc and type(bibLoad) == 'table' then
		local nbPassage = bibLoad.passage:GetNbRows();
		for i=0, nbPassage-1 do
			if bibLoad.passage:GetCellInt('Id', i) == idPassage then
				return bibLoad.passage:GetCellInt('Heure', i);
			end
		end
	end
	return -1;
end

-- watchDog qd on perd la cennection pour pouvoir la relancer?
function OnWatchDogConnect(evt)
	-- Aucune rponse du RaceResult ... on n'est pas ou plus connect
	RaceResult.Connect:SetLabel("Non Connect");
	RaceResult.battery:SetLabel('Bat=---%');
	
	if RaceResult.watchDogConnect ~= nil then
		RaceResult.watchDogConnect:Delete();
		RaceResult.watchDogConnect = nil;
	end
end

-- Fonction pour envoyer ds le chrono et base linfos souhaites 
function AddTimePassage(chrono, passage, bib, tagID)
	app.SendNotify("<passage_add>", 
		{ time = chrono,  passage = passage, bib = bib, device = 'RaceResult: '..ActiveID, tag = tagID }
	);
	bib = bib or '';
	tagID = tagID or '';
	passage = passage or '';
	chrono = chrono or '';
	Success('<passage_add tagId='..tagID..' bib='..bib..' passage='..passage..' chrono='..chrono..'>');
end
-- function propre au RaceResult IP
-- Evnement Timer
	-- timer pour la charge de la baterie 
function OnTimerBatConnect(evt)
	-- Mise en place du WatchDog
	RaceResult.watchDogConnect = timer.Create(RaceResult.panel);
	if RaceResult.watchDogConnect ~= nil then
		RaceResult.watchDogConnect:StartOnce(1000); -- Il faut moins de 1 sec au RaceResult pour rpondre 
	end
	RaceResult.panel:Bind(eventType.TIMER, OnWatchDogConnect, RaceResult.watchDogConnect);

	-- Appel Status 
	local sockClient = mt_device.obj;
	if sockClient ~= nil then
		sockClient:WriteString("GETSTATUS");
		sockClient:WriteByte(asciiCode.CR, asciiCode.LF);
	else 
		Warning("Vrifier la connection par cable thernet du dcodeur");
	end 
end

	-- reinitialisation du reseau
function OnReOpenSocket(evt)
	parentFrame = app.GetAuiFrame();
	mt_device.obj = socketClient.Open(parentFrame, theParams.hostname, theParams.port);
	parentFrame:Bind(eventType.SOCKET, mt_device.OnSocketClient, mt_device.obj);
	app.GetAuiMessage():AddLine('Socket Client '..theParams.hostname..':'..theParams.port..' Initialisation ...');
end

-- Action faite au Timer apres le lancement de la connection au decodeur
function OnTimer(evt)
	--Alert("on passe dans le timer");
	--Alert("passingCurrent :"..tostring(RaceResult.passingCurrent).."/ "..tostring(RaceResult.RecordsCount));
	RaceResult.alive = RaceResult.alive + 1;
	--*** a verif***********************************************
	OngetInfo();
	--Alert("passing count = "..tonumber(RaceResult.RecordsCount).."passingCurent = ".. tonumber(RaceResult.passingCurrent));
	
	local sockClient = mt_device.obj;
	if sockClient ~= nil then
		-- si le Nb de passing ds skiffs est > au nb de passing du decodeur on envoi juste la commande passings au decodeur pour qu'il nous renvoi le count
		if tonumber(RaceResult.passingCurrent) >= tonumber(RaceResult.RecordsCount) then
			-- Command PASSINGS 
			sockClient:WriteString("PASSINGS");
			sockClient:WriteByte(asciiCode.CR, asciiCode.LF);
			-- Alert("RaceResult.RecordsCount nb de detect lu par race result"..RaceResult.passingCurrent.." >= "..RaceResult.RecordsCount.."le nb de detection ds la ligne chrono");
		else
		-- si le count est > au pasing currant 
			-- Command PASSAGE INDIVIDUEL
			--Alert("RaceResult.RecordsCount :"..RaceResult.RecordsCount);--nb de detection ds la ligne chrono
			--Alert("RaceResult.passingCurrent :"..RaceResult.passingCurrent);--nb de passings dans skiffs
			local NbpassingsDecodeur = tonumber(RaceResult.RecordsCount) - tonumber(RaceResult.passingCurrent);
			--Alert("test NbpassingsDecodeur :"..NbpassingsDecodeur);
			if tonumber(NbpassingsDecodeur) == 1 then
			--Alert("NbpassingsDecodeur :"..NbpassingsDecodeur);
			sockClient:WriteString(tonumber(RaceResult.passingCurrent+1));
			sockClient:WriteByte(asciiCode.CR, asciiCode.LF);
			elseif tonumber(NbpassingsDecodeur) <= 0 then
			-- Alert("NbpassingsDecodeur multiple :"..NbpassingsDecodeur);
			else
			-- demande au dcodeur de renvoyer tout les passings entre le count le le passingsCurent de skiffs
			-- evite d'avoir un bug lors de l'utilisation de la fonction OnClearPassing
			--Alert("NbpassingsDecodeur multiple :"..NbpassingsDecodeur);
				if tonumber(RaceResult.passingCurrent) == 0 then 
				sockClient:WriteString(tonumber(RaceResult.passingCurrent+1)..":"..tonumber(NbpassingsDecodeur));
				sockClient:WriteByte(asciiCode.CR, asciiCode.LF);
				else 
				sockClient:WriteString(tonumber(RaceResult.passingCurrent)..":"..tonumber(NbpassingsDecodeur));
				sockClient:WriteByte(asciiCode.CR, asciiCode.LF);
				end 
			end
		end
	else	
		Warning("Le dcodeur n'est pas connecter");
	end
end

-- fonction qui lance la connection au decodeur
function OnStartRaceResult(evt)
	if TypeTable == 'ND' then 
	Warning("Pas de table de corespondance ");
	Warning("Veuillez slectionner un type de table et uploader une table via un fichier .csv ");
	else
		if RaceResult.ActiveStart == "Non Actif" then
			-- Mise du Protocol ...
			local sockClient = mt_device.obj;
			if sockClient ~= nil then
				sockClient:WriteString("SETPROTOCOL;1.8");
				sockClient:WriteByte(asciiCode.CR, asciiCode.LF);

				-- Prise de la table de Correspondance ...
				RaceResult.tagID = TabletagID_Correspondance;
				Success("Correspondance : "..TabletagID_Correspondance:GetNbRows().." ligne ds la table");
				Alert("Type de Table utiliser pour cet vnement :"..TypeTable);

				-- Creation du Timer 
				RaceResult.timer = timer.Create(RaceResult.panel);
				if RaceResult.timer ~= nil then
					RaceResult.timer:Start(RaceResult.timerDelay);
				end
				RaceResult.panel:Bind(eventType.TIMER, OnTimer, RaceResult.timer);
				RaceResult.ActiveStart = "Actif"
			else
				Warning("Le dcodeur n'est pas connecter");
			end
		else 
			Error("Dja activ !");
		end
	end
end

-- fonction qui permet d'aller ouvrir un fichier txt de sav de decodeur RaceResult ou un fichier telecharger sur le site RR et de le lire 
function OnRechargeFichier()
-- recherche du fichier se sauvegarde RaceResult
	local fileDialog = wnd.CreateFileDialog(
		{ parent = RaceResult.panel },
		"Slection du fichier de sauvegarde RaceResult",
		RaceResult.directory, 
		"",
		"*.txt|*.txt",
		fileDialogStyle.OPEN+fileDialogStyle.FD_FILE_MUST_EXIST
	);
-- si valeur bouton == OK
	if fileDialog:ShowModal() == idButton.OK then
		-- J'ouvre le fichier en mode reaad
		local file = io.open(fileDialog:GetPath(), "r");
			-- je lis ligne par ligne et active la fonction ReadPacket en lui envoyant la valeur de ligne
			if file ~= nil then -- Le Fichier Existe ...
				Alert('Chargement du fichier: '..fileDialog:GetPath());
				if RaceResult.Evt_multi_Jour == true then
					msg = "Vous aller recharger un fichier de SAV de dcodeur ou track box\n"
					msg = msg.."la date du 1er jour de domptition est le: "..RaceResult.prem_Jour_Evt.."\n"; 
					msg = msg.."si la date n'est pas correct Aller dans l'onglet configuration\n"
					msg = msg.."et modifier la date du 1er jour de comptition."
				else
					msg = "Vous aller recharger un fichier de SAV de dcodeur ou track box \n "
					msg = msg.."etes vous d\'accord."
				end 
				if RaceResult.panel:MessageBox("Confirmation du chargement du fichier ?\n\n"..msg.."","Confirmation du chargement du fichier", msgBoxStyle.YES_NO+msgBoxStyle.ICON_INFORMATION) ~= msgBoxStyle.YES then
					return;
				end
				for line in file:lines() do
					--Alert('ligne...'..line);
					RaceResult.debugage = true;
					ReadPacket(line)
				end
			file:close();
			end
		
		fileDialog:Delete();
	else
		Alert('le fichier n\'existe pas...')
		fileDialog:Delete();
		return false;
	end
end

--  lecture des trames
-- Lecture du Buffer Circulaire ...
function device.OnRead(cb)
	-- Test si le Buffer est vide 
	if cb:GetCount() == 0 then return end

	-- Lecture des Packets 
	while (ReadPacket(cb)) do end	
end

-- fonction de lecture du packet envoyer du chrono ou du fichier Txt
-- une partie de la lecture est commune au Race result RestApi
function ReadPacket(cb)
-- ligne qui permette de lire un fichier RR tlcharger
	--******************************************************************** a faire voire a pierre
	if RaceResult.debugage == true then 
		packetString = cb;
		RaceResult.debugage = false
	else
		local count =  cb:GetCount();
		
		local findEnd = cb:Find(asciiCode.CR, asciiCode.LF);	-- Recherche fin de Trame
		-- Alert('findEnd = '..findEnd..' / count = '..count);
		if findEnd == -1 then return false end  					-- On peut stopper la recherche
		local packet = cb:ReadByte(findEnd+1);
		packetString = adv.PacketString(packet, 1, findEnd);
		-- Alert("packetString.."..packetString);
	end
--********************************************************************	
	local arrayResults = string.Split(packetString,';');
	
	local countResults = #arrayResults;

	if countResults >= 1 then
		local firstResult = arrayResults[1]; 
	-- Alert("firstResult = "..firstResult);
	-- Alert("arrayResults[2] = "..arrayResults[2]);
		if tonumber(firstResult) ~= nil and tonumber(firstResult) > 0 then

			-- Impulsion de Passage
			if #arrayResults >= 4 then   

--**** recherche du dos	
				local tagID = arrayResults[2];  
				tagID = tagID:gsub('\n', '');	-- Suppression du LF ventuel
				tagID = tagID:gsub('\r', '');	-- Suppression du CR ventuel
				
				local NumLoopID = arrayResults[11];
				local NumLoopCanal = arrayResults[10];
				local SystemeActif = arrayResults[9];
				Marker = '';
				if SystemeActif == 0 and NumLoopCanal == '' and NumLoopID == '' then
					Marker = 1;
				end
				
				if NumLoopID ~= '' then 
					LoopID = 'Loop'..NumLoopID;
					LoopCanal = 'LoopCanal'..NumLoopCanal;
					SystemeActif = arrayResults[9]
				else 
					LoopID = 'Loop0';
					LoopCanal = 'LoopCanal0';
					SystemeActif = 0;
				end 
				-- Alert("LoopID = "..LoopID.." / Canal = "..LoopCanal.." / SystemeActif = "..SystemeActif )
				DecodeurDate = arrayResults[3];

				Nb_JourDecodeur = GetNb_JourDecodeur(DecodeurDate, RaceResult.prem_Jour_Evt);
				
				-- Alert("Nb_JourDecodeur:"..Nb_JourDecodeur);
				-- Alert("os.difftime(DateJour, DecodeurDate): "..os.difftime(DateJour, DecodeurDate));
				local hourPassage = arrayResults[4];
				-- Alert("	hourPassage :"..hourPassage.." et tagID = "..tagID);
-- ###### debut coupure pour tranfert //////////// code commun entre RaceResult et RaceresultWebRestApi (entre les deux coupure) suivant si on est en IP ou en webserveur////******
				local chrono = GetChrono(hourPassage, Nb_JourDecodeur);
				-- Alert("	CodeTypeTable :"..CodeTypeTable)
				-- on recherche si le CountTourActif est actif pour la Loop
				RechercheCountTourActif(CodeTypeTable,tagID, LoopID, LoopCanal);
				-- Alert("CountTourActif = "..CountTourActif)
				-- si c'est un systeme actif et que le N de LoopID ou de LoopCanal sont == 0
				-- l'impulse viens du marqquer du decodeur 
				-- if tonumber(SystemeActif) == 0 and LoopID == 'Loop0' and LoopCanal == 'LoopCanal0' then
					-- Alert("L impulse viens du marqueur du dcodeur "..ActiveID)
					-- AddTimePassage(chrono, passage, '-'..tagID, "Nmarqueur"..tagID);	
				if tonumber(SystemeActif) == 1 and LoopID == 'Loop0' and LoopCanal == 'LoopCanal0' then
					Alert("L impulse viens du marqueur du dcodeur "..ActiveID)
					--Alert(chrono..' '..passage..' '..tagID);
					AddTimePassage(chrono, passage, '-'..tagID, tagID);	
				-- elseif 	Marker == 1 then
					-- Alert("L impulse viens du marqueur du dcodeur Passif "..ActiveID)
					-- AddTimePassage(chrono, passage);	
				else -- du tonumber(SystemeActif) == 1 ou du tonumber(SystemeActif) == 0 c'est une  detection de transpondeur je continu la gestion
					-- si le CountTourActif == 0 donc non actif je gre normalement la detection comme un heure da passage
					if tonumber(CountTourActif) == 0 then
					-- Alert("je gere la detection normalement comme un chrono")			
						-- on recherche le dos et le nb de tour a faire par le dos 				
						RecherchetourDos(CodeTypeTable,tagID, LoopID, LoopCanal);
						if bib ~= "" then
							-- Alert("le Dossard : "..bib.."doit faire : "..NbToursAFaire.." Tour");
							-- Alert("le passage du Dossard : "..bib.." est : "..passage);
							-- Alert("le ID_1er_Inter du Dossard : "..bib.." est : "..ID_1er_Inter);
							--si bib est diffrent de nil ou de '' on gere l'impultion		
							if tonumber(CodeEpreuve_bib) >= 0 then
								-- recherche de l'heure de dpart de l'preuve par rapport au dossard
								local HeureDepart_Epr = rechercheHeureDepartEpreuve(bib);
								-- Alert("tostring(HeureDepart_Epr) = "..app.TimeToString(HeureDepart_Epr, "%2h:%2m:%2s.%3f"));
								-- Alert("tostring(chrono) = "..app.TimeToString(chrono, "%2h:%2m:%2s.%3f"));
								-- on regarde si la detection n'est pas inferieur a l'heure de dpart de l'preuve
								if chrono > HeureDepart_Epr then				
									-- recherche si un tagID existe dans la table TableTagID_Finish et de Rech_Der_Passage_TagID
									RechercheTagId_Rech_Der_Passage_TagID(ActiveID, LoopID, LoopCanal, tagID, bib, chrono)
									-- Alert("Rech_Der_Passage_TagID = "..Rech_Der_Passage_TagID)
									-- Alert("Rech_TagID = "..Rech_TagID)
									-- Gestion Impulsions			
										-- si Rech_TagID est diff de '' je gere l' impultion
									if Rech_TagID ~= '' then
										-- le transpondeur  deja t detecter sur la ligne
										-- recherche du nombre de tour fait par le coureur ds la Table TableTagID_Finish
										NbTourRealiser = 0;
										NbTourRealiser = GetNbTourRealiser(tagID);
										-- Alert("NbTourRealiser: "..NbTourRealiser);
											
										-- Recherche du delay de double detection
										local DelayDoubleDetect = GetDelayDoubleDetect();
										-- Alert("DelayDoubleDetect: "..DelayDoubleDetect);
											
										-- incrementation de la variable passage suivant le Nb  faire te le Nb de tour raliser
										-- Alert("NbTourRealiser: "..NbTourRealiser.." Nb ToursAFaire : "..NbToursAFaire);
										passage = GetPassage(NbToursAFaire, NbTourRealiser, bib); 
										-- Alert("passage apres le GetPassage = "..passage);
										if tonumber(ImpulSynchro) == 1 then
											AddTimePassage(chrono, Rech_Der_Passge_TagID, -5555, tagID.."(ds)");
											-- AddTimesTagIDFinish(tagID, passage, LoopID, LoopCanal, Tour, bib);
											-- refreshTagIDFinish(tagID, passage, LoopID, LoopCanal);
											ImpulSynchro = nil;
											--Alert("passage = "..passage);
										else
											-- rechercher si une heure de passage est deja inscrite dans la table chrono
											-- local TimePassage = GetHeurePassage(bib, Rech_Der_Passage_TagID);	
											local TimePassage = rechercheHeurePassageBib(bib, Rech_Der_Passage_TagID);
												-- Alert(" chrono = "..chrono.." TimePassage = "..TimePassage);
												-- Alert("Rech_Der_Passage_TagID = "..Rech_Der_Passage_TagID);
											-- Calcul de l'heure de passage + delay double detection
											local TimePassagePlus = tonumber(TimePassage) + tonumber(DelayDoubleDetect); 
												--Alert(" TimePassagePlus ="..TimePassagePlus)
												-- si le l'heure dedetection 'chrono' est inferieur a tps + DelayDoubleDetect c'est une double dtection
												
											if 	tonumber(chrono) <= tonumber(TimePassagePlus)then 
												TimeDelayDoubleDetect = tonumber(DelayDoubleDetect / 1000);
												TimeDelayDoubleDetect = tonumber(TimeDelayDoubleDetect / 60);
												-- Alert("Attention Double detection delai entre les 2 detections < "..TimeDelayDoubleDetect.."Min");
												-- Alert("Nb Tour fait: "..NbTourRealiser.."/ "..NbToursAFaire.." Tours  Faire")
												AddTimePassage(chrono, Rech_Der_Passage_TagID, -6666, tagID.."(d)");
											
											-- Sinon c'est une impultion normal on peu continuer la gestion	
											else -- du tonumber(chrono) <= tonumber(TimePassagePlus)
												-- **** si le delay de double detection est passer je gere l'impultion normalement
												-- Alert(" heure de passage > au DelayDoubleDetect on peu gerer l'impultion normalement");		
												-- Si le nb de tour realiser est == au nb de tour a faire je met l' heure ds la table
												if NbToursAFaire == -1 then
													-- Alert("LoopID 1 = "..LoopID);
													AddNbTours(NbTourRealiser+1, tagID, ActiveID, LoopID, LoopCanal);
													AddTimePassage(chrono, Id_Passage, bib, tagID);
													refreshTagIDFinish(tagID, Id_Passage, LoopID, LoopCanal);												
												elseif NbTourRealiser < NbToursAFaire then  
													-- Alert("LoopID 1 = "..LoopID);
													AddNbTours(NbTourRealiser+1, tagID, ActiveID, LoopID, LoopCanal);
													AddTimePassage(chrono, Rech_Der_Passage_TagID+1, bib, tagID);
													refreshTagIDFinish(tagID, Rech_Der_Passage_TagID+1, LoopID, LoopCanal);
												elseif	NbTourRealiser == NbToursAFaire then 
													-- Alert("LoopID 2 = "..LoopID);
													AddNbTours(NbTourRealiser+1, tagID, ActiveID, LoopID, LoopCanal);
													AddTimePassage(chrono, passage, bib, tagID);
													refreshTagIDFinish(tagID, passage, LoopID, LoopCanal);
												elseif NbTourRealiser > NbToursAFaire then
													-- Alert("LoopID 3 = "..LoopID);
													AddNbTours(NbTourRealiser+1, tagID, ActiveID, LoopID, LoopCanal);
													AddTimePassage(chrono, passage, -bib, tagID);
												end
											end 
										end
									else	-- du if Rech_TagID ~= '' c'est la premiere detection du tagID j'envoi le temps ds la base
										-- Alert('premiere detection NbTourRealiser = '..NbTourRealiser..'NbToursAFaire = '..NbToursAFaire)						
										-- Alert('passage = '..passage)
										if NbToursAFaire == 0 then
											-- Alert('Le concurent n\'a pas de tour  faire j\'ecrit dans la table TableTagID_Finish')
											AddTimePassage(chrono, passage, bib, tagID);
											AddTimesTagIDFinish(tagID, passage, LoopID, LoopCanal, 1, bib)
										elseif NbToursAFaire == -1 then
											-- Alert("LoopID 1 = "..LoopID);
											AddTimePassage(chrono, passage, bib, tagID);
											AddTimesTagIDFinish(tagID, passage, LoopID, LoopCanal, 1, bib)											
										else
											-- Alert('Le concurent a des tour  faire j\'ecrit dans la table TableTagID_Finish')
											-- Alert('j' envoi le temps ds la table resultat chrono')
											AddTimePassage(chrono, ID_1er_Inter, bib, tagID);
											AddTimesTagIDFinish(tagID, ID_1er_Inter, LoopID, LoopCanal, 1, bib, DecodeurDate);
										end
									end
								else -- du if chrono > HeureDepart_Epr then
									Alert("Dtection avant l\'heure de dpart de l\'preuve:  "..app.TimeToString(HeureDepart_Epr, "%2h:%2m:%2s"))
									AddTimePassage(chrono, passage, -bib, tagID.."(Und)");
									-- SavePassingCurrent(tonumber(firstResult));
								end -- du if chrono > HeureDepart_Epr then
							else -- de if Code_epreuve >=1	
								Warning("Coureur n\'tant pas affecter  une preuve")
								AddTimePassage(chrono, Id_Passage, '+'..bib, tagID.."(Epr)");	
							end	
						else -- si bib = '' le tagID est inconnu ds la table de corespondance je met un dos -9999 pour le signaler au chrono et ne pas perdre l'impulse
							Warning("Tag ID inconnu dans la TableCorrespondance:  ")
							AddTimePassage(chrono, Id_Passage, -9999, tagID);
						end -- de if bib ~= ""						
						
					else -- de if tonumber(CountTourActif) == 0  CountTourActif=1
					-- la Ligne de detection sert  compter le Nb tour de Pena..... 
						Alert("La dtection viens de la Loop de comptage de tour de pna");
						-- On recherche les infos du bib
						RecherchetourDos(CodeTypeTable,tagID, LoopID, LoopCanal);
		        		if bib ~= "" then
							-- Alert("le Dossard : "..bib.."doit faire : "..NbToursAFaire.." Tour");
							-- Alert("le passage du Dossard : "..bib.." est : "..passage);
							Alert("le ID_1er_Inter du Dossard : "..bib.." est : "..ID_1er_Inter);
							Alert("CodeEpreuve_bib = "..CodeEpreuve_bib);
							-- Alert("le Tps au Tour mini est = "..Tps_Tour);
							-- Alert("le temps mini du tour de Pnalit est de : "..Tps_Tour_Pena);
							if tonumber(CodeEpreuve_bib) >= 0 then
								-- recherche de l'heure de dpart de l'preuve par rapport au dossard
								local HeureDepart_Epr = rechercheHeureDepartEpreuve(bib);
								-- Alert("tostring(HeureDepart_Epr) = "..app.TimeToString(HeureDepart_Epr, "%2h:%2m:%2s.%3f"));
								-- Alert("tostring(chrono) = "..app.TimeToString(chrono, "%2h:%2m:%2s.%3f"));
								-- on regarde si la detection n'est pas inferieur a l'heure de dpart de l'preuve
								if chrono > HeureDepart_Epr then
									-- ImpulSynchro = 0;
									RechercheTagId_Rech_Der_Passage_TagID(ActiveID, LoopID, LoopCanal, tagID, bib, chrono)
									if tonumber(ImpulSynchro) == 1 then
										local tagID = tagID.."(ds)"
										AddTimePassage(chrono, Rech_Der_Passge_TagID, -5555, tagID);
										-- AddTimesTagIDFinish(tagID, passage, LoopID, LoopCanal, Tour, bib);
										-- refreshTagIDFinish(tagID, passage, LoopID, LoopCanal);
										ImpulSynchro = nil;
										--Alert("passage = "..passage);
									else
										-- recherche si un tagID existe dans la table TagID_TourPena									
										local Rech_Dossard = rechercheDos_TabletagID_TourPena(ActiveID, LoopID, LoopCanal, bib)
										--Alert("Rech_Dossard = "..Rech_Dossard);
										if Rech_Dossard == '' then
											Alert("Je creer un ligne pour le comptage de tour de pena ds la table tagID_TourPena")
											-- Je creer un ligne pour le comptage de tour de pena ds la table tagID_TourPena
											AddTimePassage(chrono, Id_Passage, bib, tagID);
											First_Tir = GetFirst_Tir(ActiveID, LoopID, LoopCanal, bib, chrono);
											InsertNbTour_Pena(ActiveID, LoopID, LoopCanal, bib, First_Tir, 1, 1, chrono);
										else
											-- Recherche du delay de double detection
											local DelayDoubleDetect = GetDelayDoubleDetect();
											-- Alert("DelayDoubleDetect = "..tonumber(DelayDoubleDetect/10000)..'sec.'); 
											-- Alert("bib = "..bib)
											-- Alert("passage: "..passage);
											-- Alert("DelayDoubleDetect: "..DelayDoubleDetect);
											local TimePassage = GetHeurePassage(Rech_Dossard, passage);
											--Alert("TimePassage: "..TimePassage);
											
											local TimePassagePlus = tonumber(TimePassage)+4000;
											--Alert("chrono = "..chrono)
											--Alert("TimePassage = "..TimePassage.." TimePassagePlus ="..TimePassagePlus)
												if 	tonumber(chrono) <= tonumber(TimePassagePlus)then
													TimeDelayDoubleDetect = tonumber(DelayDoubleDetect / 1000);
													TimeDelayDoubleDetect = tonumber(TimeDelayDoubleDetect / 60);
													Alert("Attention Double detection delai entre les 2 detections < "..TimeDelayDoubleDetect.."Min");
													--Alert("Nb Tour fait: "..NbTourRealiser.."/ "..NbToursAFaire.." Tours  Faire")
													AddTimePassage(chrono, Id_Passage, -6666, tagID.."(d)");
												else
													Bib_Chrono = 0;
													-- Sinon si le l'heure dedetection 'chrono' est superieur  tps + DelayDoubleDetect c'est une impulse corect je gere la detection
													GetInfo_Tir(ActiveID, LoopID, LoopCanal, bib, chrono);
													Alert("Num_Tir = "..Num_Tir);
													--Alert("NbTour_Fait = "..NbTour_Fait);
													
													AddNbTour_Pena(ActiveID, LoopID, LoopCanal, bib, Tir, NbTourPenaRealiser+1, Num_Tir, Total_TrPena+1, chrono);
													AddTimePassage(chrono, Id_Passage, bib, tagID);
													Alert("Total_TrPena = "..Total_TrPena+1);
												end
										end -- du Rech_Dossard == '' then	
									end
								else -- du if chrono > HeureDepart_Epr then
									Alert("Dtection avant l\'heure de dpart de l\'preuve:  "..app.TimeToString(HeureDepart_Epr, "%2h:%2m:%2s"))
									AddTimePassage(chrono, Id_Passage, -bib, tagID.."(Und)");
								end --if chrono > HeureDepart_Epr then
							else --du if tonumber(CodeEpreuve_bib) >= 0 then
								AddTimePassage(chrono, Id_Passage, bib, tagID);
							end -- if tonumber(CodeEpreuve_bib) >= 0 then	
								--AddTimePassage(chrono, Id_Passage, bib, tagID);
						else -- if bib ~= "" then
							-- si le dossard est inconnu je met -7777 en bib
							AddTimePassage(chrono, Id_Passage, -7777, tagID);
						end -- if bib ~= "" then
					end -- de if tonumber(CountTourActif) == 0
				end -- de if tonumber(SystemeActif)
-- ###### fin coupure pour tranfert //////////// code commun entre RaceResult et RaceresultWebRestApi (entre les deux coupure) suivant si on est en IP ou en webserveur////******						
			-- on sauvegarde le Nb de detection lu
			SavePassingCurrent(tonumber(firstResult));
			end

		-- PASSINGS
		elseif firstResult == 'PASSINGS' then
			if #arrayResults >= 2 then
				RaceResult.RecordsCount = tonumber(arrayResults[2]);
			end
			
		-- GETSTATUS
		elseif firstResult == 'GETSTATUS' then
			-- Suppression du WatchDog
			if RaceResult.watchDogConnect ~= nil then
				RaceResult.watchDogConnect:Delete();
				RaceResult.watchDogConnect = nil;
			end
		
		RaceResult.Connect:SetLabel("Connect");
			
			if RaceResult.GetStatus == 'Ok'then
				Success(packetString);
				RaceResult.GetStatus = 'Ko'
				return RaceResult.GetStatus
			else 
			--Alert ('envoiGetStatus KO')
			end	 
			
			local batteryCharge = tonumber(arrayResults[11]);
			RaceResult.battery:SetLabel("Charge Bat ="..batteryCharge..'%');
			if batteryCharge < 10 then
				Warning("Charge de la batterie trop faible: "..batteryCharge.."%");
			end
		
		-- PING;PONG
		elseif firstResult == 'PING' and #arrayResults >= 2 and arrayResults[2] == 'PONG' then
			Success('PONG reu ! Dcodeur connecter');
		-- ----
		elseif firstResult == 'GETTIME' then
			Success(packetString);
		-- GETPROTOCOL
		elseif firstResult == 'GETPROTOCOL' then
			--NProtocol = arrayResults[2]..'/'..arrayResults[3]..'/'..arrayResults[4]..'/'..arrayResults[4]..'.'
			Success('protocol pris en compte par le decodeur: '..packetString);
			
		elseif firstResult == 'GETMODE' then
			ModeChrono = arrayResults[2];
				if ModeChrono == 'OPERATION' then
				Success("decodeur en mode Chrono: "..ModeChrono);
				elseif ModeChrono == 'TEST' then
				Warning("decodeur en mode Test "..ModeChrono);
				else
				alert("Mode chrono non traiter pour l'instand")
				end
				
		elseif firstResult == 'SETPROTOCOL' then		
				SetProtocol = arrayResults[2];	
				Alert("Protocol utilis par le decodeur : "..SetProtocol)
				
		elseif firstResult == 'STARTOPERATION' and #arrayResults >= 2 and arrayResults[2] == 'OK' then
			Success('Ligne Active');	
		elseif firstResult == 'STARTOPERATION' and #arrayResults >= 2 and arrayResults[2] == 'OPERATIONMODE' then
			Alert("Chrono dj actif");
		elseif firstResult == 'STOPOPERATION' and #arrayResults >= 2 and arrayResults[2] == 'OK' then
			Warning('Ligne Dsactive plus de dtection de Transpondeur decodeur en mode Chrono: Test');
		elseif firstResult == 'STARTUPLOAD' and #arrayResults >= 2 and arrayResults[2] == 'OK' then
			Alert('Activation de l\'Upload');
		elseif firstResult == 'STOPUPLOAD' and #arrayResults >= 2 and arrayResults[2] == 'OK' then
			Alert('Arret de l\'Upload');
		elseif firstResult == 'SETGPSTIME' and #arrayResults >= 2 and arrayResults[2] == 'NOSATELITES' then	
			Alert("Pas de satelite pour la synchronisation");
		elseif firstResult == 'SETGPSTIME' and #arrayResults >= 2 and arrayResults[2] == 'ERROR' then	
			Warning("Erreur  d'envoi");
		elseif firstResult == 'SETGPSTIME' and #arrayResults >= 2 and arrayResults[2] == 'OPERATIONMODE' then	
			Alert("Synchronisation en court");
		elseif firstResult == 'SETGPSTIME' and #arrayResults >= 2 and arrayResults[2] == 'OPERATIONMODE' then	
			Alert("Synchronisation en court");
		elseif firstResult == 'SETGPSTIME' and #arrayResults >= 2 and string.sub(arrayResults[2], 1, 2) == '20' then	
			Alert("Synchro GPS OK..."..arrayResults[2]);
		--elseif firstResult == 'ONLY '..tostring(RaceResult.RecordsCount) then
			--NumPassings = arrayResults[2];
			--Alert('Commande ONLY envoie du passing :'..NumPassings);
		
		elseif firstResult ~= '' then
			-- Rponse autre commandes alert lors de la detection des puces... Only11
			Alert('Commande '..firstResult..' non prise en compte :'..packetString);
		end
	end

	return true;	-- il faut poursuivre la recherche	
end

