-- ESF Data Exchange XML Protocol 	
-- version 1.4

function before_esf_competition(t)
	base:SetGlobalVariable({'table', 'record'}); -- tName => table Name, rName => record Name
	base:SetBaseFormatChrono('ESF');
	
	if mode == 'import' then
		tEvenement:AddRow();
		
		rEpreuve:Set('Code_epreuve', 1);
		rEpreuve:Set('Nombre_de_manche', 1);
		tEpreuve:AddRow();

		tResultat_Copy = tResultat:Copy(false, true);
		tResultat_Adresse_Copy = tResultat_Adresse:Copy(false, true);
		tResultat_Manche_Copy = tResultat_Manche:Copy(false, true);
	end
end

function after_esf_competition(t)
	xmlError = xmlError or {};
	if mode == 'import' then
		if #xmlError == 0 then
			-- Verification table Evenement - Mise des valeurs par dfaut ...
			if tEvenement:IsCellNull('Code_activite', 0) then tEvenement:SetCell('Code_activite', 0, 'ESF') end
			if tEvenement:IsCellNull('Code_entite', 0) then tEvenement:SetCell('Code_entite', 0, 'ESF') end
			if tEvenement:IsCellNull('Code_saison', 0) then tEvenement:SetCell('Code_saison', 0, base:GetActiveSaison()) end
			if tEvenement:IsCellNull('Code_origine', 0) then tEvenement:SetCell('Code_origine', 0, 'ESF') end
			tEvenement:SetCell('Code_calendrier', 0, 'LOCAL');
			tEvenement:SetCell('Code_gestion', 0, -1);	-- STATUS_WAIT

			-- Verification table Epreuve - Mise des valeurs par dfaut ...
			if tEpreuve:IsCellNull('Code_grille_categorie', 0) then tEpreuve:SetCell('Code_grille_categorie', 0, 'SKIOPEN') end
			if tEpreuve:IsCellNull('Code_categorie', 0) then tEpreuve:SetCell('Code_categorie', 0, '*') end
			tEpreuve:SetCell('Code_niveau', 0, 'ESF');
			tEpreuve:SetCell('Code_calendrier', 0, 'LOCAL');
			tEpreuve:SetCell('Code_gestion', 0, etatEpreuve.Course);

			-- Transfert Final des tables Resultats ...
			tResultat:RemoveAllRows(); tResultat:AddRow(tResultat_Copy);
			tResultat_Adresse:RemoveAllRows(); tResultat_Adresse:AddRow(tResultat_Adresse_Copy);
			tResultat_Manche:RemoveAllRows(); tResultat_Manche:AddRow(tResultat_Manche_Copy);

			base:InsertBaseEvenement();
		end
	end
end

function after_date_course(t)
	if mode == 'import' then
		local dateEpr;
		dateEpr = t.children.annee[1].content..'/';
		dateEpr = dateEpr..string.format('%02d', tonumber(t.children.mois[1].content))..'/';
		dateEpr = dateEpr..string.format('%02d', tonumber(t.children.jour[1].content));
		tEpreuve:SetCell('Date_epreuve', 0, dateEpr);

		if type(t.children.heure) == 'table' and type(t.children.minute) == 'table' then
			tEpreuve:SetCell('Tir', 0, string.format('%02d', tonumber(t.children.heure[1].content))..':'..string.format('%02d', tonumber(t.children.minute[1].content)));
		end
		
	else
		t.children.annee[1].content = tEpreuve:GetCell('Date_epreuve', 0, '%4Y');
		t.children.mois[1].content = tEpreuve:GetCell('Date_epreuve', 0, '%2M');
		t.children.jour[1].content = tEpreuve:GetCell('Date_epreuve', 0, '%2D');
	end
end

function after_competition_entete(t)
	if mode == 'import' then
		local circuit = t.attributes.circuit or '';
		if circuit == 'HORS_CIRCUIT' then circuit = '-' end
		tEpreuve:SetCell('Info', 0, circuit);

		if circuit == 'MEMO' or circuit == 'TBP' then
			tEpreuve:SetCell('Code_regroupement', 0, 'MEMO');
		elseif circuit == 'STAGIAIRE' then
			tEpreuve:SetCell('Code_regroupement', 0, 'STAGIAIRE');
		elseif circuit == 'NCROS' then 
			tEpreuve:SetCell('Code_regroupement', 0, 'NCROS');
		elseif circuit == 'CLUBESF' then
			tEpreuve:SetCell("Code_regroupement", 0, 'CLUBESF');
		else
			tEpreuve:SetCell("Code_regroupement", 0, 'SKIOPEN');
		end
		
		local code_esf = tEvenement:GetCell('Code_club', 0);
		tEvenement:SetCell('Club', 0, base:GetEsfLabel(code_esf));
	end
end

function before_competition_ouverture(t)
	if mode == 'import' then
		code_ouvreur = code_ouvreur or 0;
		code_ouvreur = code_ouvreur + 1;
		
		tEpreuve_Alpine_Manche_Ouvreur:GetRecord():Set("Code", code_ouvreur);
		tEpreuve_Alpine_Manche_Ouvreur:AddRow();
	else
		return base:TableLoad(tResultat, 'Select * From Epreuve_Alpine_Manche_Ouvreur Where Code_evenement = '..Code_evenement);
	end
end

function after_competition_ouverture(t)
	if mode == 'import' then
		local code_manche = tonumber(t.attributes.manche) or 1;
		if code_manche >= tEpreuve:GetCellInt('Nombre_de_manche', 0, 1) then
			tEpreuve:SetCell('Nombre_de_manche', 0, code_manche);
		end
		local row = tEpreuve_Alpine_Manche_Ouvreur:GetNbRows()-1;
		if row >= 0 then
			tEpreuve_Alpine_Manche_Ouvreur:SetCell("Code_manche", row, code_manche);
		end
	end
end

function content_code_coureur(t) 
	if mode == 'import' then 
		local contentValue = t.content or '';
		if contentValue:len() == 0 then	
			MessageWarning("Prsence d'une Balise <code_coureur> Vide !!!");
		end
		if t.attributes ~= nil and t.attributes.type ~= nil then
			return t.attributes.type..contentValue;
		else
			return 'ESF'..contentValue; 
		end
	else 
		return t.content:sub(4);
	end 
end

function content_sexe(t) 
	if mode == 'import' then 
		if t.attributes ~= nil and t.attributes.sexe ~= nil then
			return t.attributes.sexe;
		else
			return '';
		end
	end 
end

function content_temps(t) 
	if mode == 'import' then 
		if t.attributes ~= nil and t.attributes.etat ~= nil then
			local etat = t.attributes.etat;
			if etat == 'OK' then
				return t.content or 'Nt';
			else
				return etat;
			end
		else
			return 'NT'
		end
	end
end

function before_competition_concurrent(t)
	if mode == 'import' then
		tResultat:AddRow();
		tResultat_Adresse:AddRow();
	else
		return base:TableLoad(tResultat, 'Select * From Resultat Where Code_evenement = '..Code_evenement);
	end
end

function after_competition_concurrent(t)
	if mode == 'import' then
		Code_coureur = tResultat:GetCell('Code_coureur', 0);

		for i=0, tResultat_Adresse:GetNbRows()-1 do tResultat_Adresse:SetCell('Code_coureur',i, Code_coureur) end
		for i=0, tResultat_Manche:GetNbRows()-1 do tResultat_Manche:SetCell('Code_coureur',i, Code_coureur) end
		
		tResultat_Copy:AddRow(tResultat); tResultat:RemoveAllRows();
		tResultat_Adresse_Copy:AddRow(tResultat_Adresse); tResultat_Adresse:RemoveAllRows();
		tResultat_Manche_Copy:AddRow(tResultat_Manche); tResultat_Manche:RemoveAllRows();
	end
end

function before_manche_concurrent(t)
	if mode == 'import' then
		tResultat_Manche:AddRow();
	else
		return base:TableLoad(tResultat, 'Select * From Resultat_Manche Where Code_evenement = '..Code_evenement);
	end
end

function after_manche_concurrent(t)
	if mode == 'import' then
		local row = tResultat_Manche:GetNbRows()-1;
		if row >= 0 then
			tResultat_Manche:SetCell('Code_manche', row, t.attributes.manche);
		end
	end
end

--------------------------- XML Description tables ---------------------------

competition_entete = { 
	after = after_competition_entete,
	attributes = { 
		{name = 'circuit', value = 'SKIOPEN|MEMO|TBP|STAGIAIRE|BSB|NCROS|CLUBESF|HORS_CIRCUIT|NSC'}, 

		{name = 'total_manche', type_value = 'integer'},
		{name = 'denivele', type_value = 'integer', optional = true },

	}, children = {
		{ name = 'discipline', field = 'Epreuve.Code_discipline' },
		{ name = 'code_esf', field = 'Evenement.Code_club' },
		{ name = 'organisateur', field = 'Evenement.Organisateur' },
		{ name = 'nom_course', field = 'Evenement.Nom' },
		{ name = 'commentaire', field = 'Evenement.Commentaire' },
		{ name = 'logiciel', field = 'Evenement.Responsable' },
		{ name = 'date_course', children = { 
			{ name = 'annee', content = "integer" } ,
			{ name = 'mois', content = "integer" },
			{ name = 'jour', content = "integer" },
			{ name = 'heure', content = "integer", required = '0-1' },
			{ name = 'minute', content = "integer", required = '0-1' },
			}, after = after_date_course
		}
	}
};

competition_ouverture = { 
	required = '0-9', 
	before = before_competition_ouverture,
	after = after_competition_ouverture,
	attributes = { 
		{name = 'manche', type_value = 'integer'},
	}, children = {
		{ name = 'cs_ouvreur', field = 'Epreuve_Alpine_Manche_Ouvreur.Matric' },
		{ name = 'nom_ouvreur', field = 'Epreuve_Alpine_Manche_Ouvreur.Nom' },
		{ name = 'prenom_ouvreur', field = 'Epreuve_Alpine_Manche_Ouvreur.Prenom' },
		{ name = 'handicap', field = 'Epreuve_Alpine_Manche_Ouvreur.Handicap' },
		{ name = 'temps_realise', content = content_temps, field = 'Epreuve_Alpine_Manche_Ouvreur.Tps' },
		{ name = 'temps_base', content = content_temps, field = 'Epreuve_Alpine_Manche_Ouvreur.Base' }
	}
};

manche_concurrent = { 
	required = '1-9', 
	before = before_manche_concurrent,
	after = after_manche_concurrent,
	attributes = { 
		{name = 'manche', type_value = 'integer'},
	}, children = {
		{ name = 'temps', attributes = { {name = 'etat', value = 'OK|ABD|DSQ|ABS|-'} }, content = content_temps, field = 'Resultat_Manche.Tps_chrono'  },
		{ name = 'medaille', field = 'Resultat_Manche.Medaille' },
		{ name = 'pourcentage', field = 'Resultat_Manche.Pts' },
		{ name = 'point', field = 'Resultat_Manche.PtsClt' }
	}
};

competition_concurrent = { 
	required = '0-99999', 
	before = before_competition_concurrent,
	after = after_competition_concurrent,

	children = {
		{ name = 'code_coureur', content = content_code_coureur, attributes = {{ name = 'type', type_value = 'string' }}, field = 'Resultat.Code_coureur' },
		{ name = 'dossard', field = 'Resultat.Dossard' },
		{ name = 'nom', field = 'Resultat.Nom' },
		{ name = 'prenom', field = 'Resultat.Prenom' },
		{ name = 'sexe', content = content_sexe, field = 'Resultat.Sexe' },
		{ name = 'naissance', children = { { name = 'annee', field = 'Resultat.An' } } }, 
		{ name = 'annee', field = 'Resultat.An', required = '0-1'},
		{ name = 'groupe', field = 'Resultat.Groupe' },
		{ name = 'equipe', field = 'Resultat.Equipe' },
		{ name = 'critere', field = 'Resultat.Critere' },

		{ name = 'email', content = 'string', required = '0-1', field = 'Resultat_Adresse.Email' },
		{ name = 'adresse', content = 'string', required = '0-1', field = 'Resultat_Adresse.Adresse1' },
		{ name = 'code_postal', content = 'string', required = '0-1', field = 'Resultat_Adresse.Code_postal' },
		{ name = 'ville', content = 'string', required = '0-1', field = 'Resultat_Adresse.Ville' },
		{ name = 'pays', content = 'string', required = '0-1', field = 'Resultat_Adresse.Code_postal' },
		{ name = 'tel', content = 'string', required = '0-1', field = 'Resultat_Adresse.Tel' },

		{ name = 'manche_concurrent', props = manche_concurrent },
		{ name = 'temps_total', content = 'string', required = '0-1' },
		{ name = 'point_total', field = 'Resultat.Pts', required = '0-1' },
	}
};

-- Point d'entre principale de la Grammaire XML 
xmlDescription = {
	name = 'esf_competition', 
	before = before_esf_competition,
	children = {
		{ name = 'competition_entete', props = competition_entete },
		{ name = 'competition_ouverture', props = competition_ouverture },
		{ name = 'competition_concurrent', props = competition_concurrent },
	},
	after = after_esf_competition
};